-- Bench.ex
-- /Mic, 2000


without warning

include triangle.e


constant XDIM=100, YDIM=100


atom vscreen,texture
atom t1,t2
sequence times
integer BPP,key
integer ITERATIONS


puts(1,"Simple triangle-filling benchmark program\n")
puts(1,"By Mic, 1999/2000\n\n")
puts(1,"Color depth?\n")
puts(1,"[1] 8 bits\n[2] 15 bits\n[3] 16 bits\n[4] 24 bits\n\n[0] abort\n")
key = 0
while ((key<'0') or (key>'4')) do
  key = get_key()
end while

if key='0' then
  abort(0)
elsif key='1' then
  BPP = 8
  ITERATIONS = 30000
elsif key='2' then
  BPP = 15
  ITERATIONS = 15000
elsif key='3' then
  BPP = 16
  ITERATIONS = 15000
elsif key='4' then
  BPP = 24
  ITERATIONS = 9000
end if

if render_mode(XDIM,YDIM,BPP) then end if


clear_screen()
texture = allocate(256*256*floor((BPP+1)/8))

times = {0,0,0}
vscreen = allocate(100*100*floor((BPP+1)/8))
if vscreen=0 then
  puts(2,"Doh! Unable to allocate memory for virtual screen!\n")
  abort(1)
end if

puts(1,"\nTiming performance...\n\n")

puts(1,"Timing draw_tri()")
t1 = time()
for i = 1 to ITERATIONS do
  draw_tri({{0,0},{XDIM-1,0},{XDIM,YDIM}-1},4,vscreen)
end for
t2 = time()
if (t2-t1)!=0 then
  times[1] = (ITERATIONS*XDIM*YDIM/2)/(t2-t1)
else
  times[1] = (ITERATIONS*XDIM*YDIM/2)
end if
puts(1,"         [DONE]\n")



puts(1,"Timing draw_gouraudtri()")
t1 = time()
for i = 1 to ITERATIONS do
  draw_gouraudtri({{0,0},{XDIM-1,0},{XDIM,YDIM}-1},{4,14,24,45},vscreen)
end for
t2 = time()
if (t2-t1)!=0 then
  times[2] = (ITERATIONS*XDIM*YDIM/2)/(t2-t1)
else
  times[2] = (ITERATIONS*XDIM*YDIM/2)
end if
puts(1,"  [DONE]\n")


ITERATIONS = floor(ITERATIONS/2)

puts(1,"Timing draw_texturetri()")
t1 = time()
for i=1 to ITERATIONS do
  draw_texturetri({{0,0},{XDIM-1,0},{XDIM,YDIM}-1},{{0,0},{255,255},{0,255}},texture,vscreen)
end for
t2 = time()
if (t2-t1)!=0 then
  times[3] = (ITERATIONS*XDIM*YDIM/2)/(t2-t1)
else
  times[3] = (ITERATIONS*XDIM*YDIM/2)
end if
puts(1,"  [DONE]\n")



clear_screen()
puts(1,"Million pixels per second:\n")
printf(1," Single-colored:     %1.2f\n",times[1]/1000000.0)
printf(1," Gouraud-shaded:     %1.2f\n",times[2]/1000000.0)
printf(1," Textured      :     %1.2f\n",times[3]/1000000.0)
printf(1,"\n(Color depth: %d bits)\n",BPP)

free(texture)
free(vscreen)
