include asm.e
include ports.e


constant no_fading=-666
constant no_delay=-667


sequence inRegs,outRegs

--** <Assembly code> **--

--*** Copy one screen to another ***--
global constant show_buffer_code=get_asm(
"pusha cld "&
"mov edi,655360 "&		--address of vga memory
"mov esi,copy_src_addr "&
"mov ecx,16000 "&
"rep movsd "&
"popa ret ")
global constant copy_src_addr=show_buffer_code+get_param("copy_src_addr")

--*** Wait for a vertical retrace ***--
global constant wait_vrt_code=get_asm(
"pusha cld "&
"mov edx,986 "&
"waitLbl1: "&
"in ax,dx "&
"and al,8 "&
"jnz waitLbl1 "&
"waitLbl2: "&
"in ax,dx "&
"and al,8 "&
"jz waitLbl2 "&
"popa ret")

--** </Assembly code> **--


--** <Misc stuff> **--

--*** Set mode 19 ***--
global procedure set_vga()
outRegs={0,0,0,0,0,0,0,0,0,0}
outRegs[REG_AX]=#13
inRegs=dos_interrupt(#10,outRegs)
end procedure

--*** Restore graphics mode and free some memory ***--
global procedure shut_down()
 if machine_func(5,-1) then end if
-- free(asm_xmin)
-- free(ghl_code)
-- free(thl_code)
-- free(thl_deltaX)
-- free(show_buffer_code)
-- free(wait_vrt_code)
-- free(sgps_code)
-- free(sgps_data)
-- free(stps_code)
-- free(stps_data)
-- free(reset_minmax_buffers)
end procedure


--** poke a bitmap into memory **--
global function poke_bitmap(sequence tha_bgf_img)
sequence ret_seq
atom tha_mem_space
 tha_mem_space=allocate((length(tha_bgf_img)*length(tha_bgf_img[1])))
 ret_seq=repeat(0,3)
 for i=1 to length(tha_bgf_img) do
  poke(tha_mem_space+(length(tha_bgf_img[1])*(i-1)),tha_bgf_img[i])
 end for
 ret_seq[1]=tha_mem_space
 ret_seq[2]=length(tha_bgf_img[1])
 ret_seq[3]=length(tha_bgf_img)
 return ret_seq
end function


--** copy a virtual screen to vga memory **--
global procedure asm_show_buffer(atom src)
 poke4(copy_src_addr,src)
 call(show_buffer_code)
end procedure

--** clear a screen **--
global procedure mem_cls(atom tha_screen_addr,integer tha_col)
 mem_set(tha_screen_addr,tha_col,640*480)
end procedure

global procedure mem_cls_clip(atom tha_screen_addr,integer tha_col,sequence clip_box_coords)
integer cb_len
cb_len=(clip_box_coords[2][1]-clip_box_coords[1][1])+1
for i=clip_box_coords[1][2] to clip_box_coords[2][2] do
mem_set(tha_screen_addr+(i*640)+clip_box_coords[1][1],tha_col,cb_len)
end for
end procedure

--** wait for a vertical retrace **--
global procedure wait_vrt()
--call(wait_vrt_code)		--didn't work on some videocards (at least one model..)
 while (and_bits(Input(#03DA),8)!=0) do		--this works fine though
 end while
 while (and_bits(Input(#03DA),8)=0) do
 end while
end procedure

--** set the specified palette **--
global procedure set_pal(sequence tha_pal)
for i=1 to 256 do
Output(i-1,#3C8)
Output(tha_pal[i][1],#3C9)
Output(tha_pal[i][2],#3C9)
Output(tha_pal[i][3],#3C9)
end for
end procedure

--** </Misc stuff> **--




