--		Fast triangle fillers + a bunch of misc. routines for Euphoria 2.1+
--						  v. 00.10.30
--					      Mic, 1999/2000



include asm.e


constant rScreenW=allocate(4),rScreenH=allocate(4),rDummy=allocate(4),
         rMaxW=allocate(4),rMaxH=allocate(4),
         hl24_color=allocate(4),rClip=allocate(16),
         rFlatY=allocate(64),rFlatNumLines=rFlatY+4,rFlatColor=rFlatY+8,
         rFlatScrAddr=rFlatY+12,rFlatCode=rFlatY+16,
         rBytesOnScreen=rFlatY+20,rFCopyIter=rFlatY+24,rClsIter=rFlatY+28,
         rGouraudCode=rFlatY+32,rTextureCode=rFlatY+36,rTexture=rFlatY+40, 
         texY=1,texNumLines=2,texScrAddr=3,texTexture=4,texCode=5,texScan=6 

integer render_screenW,render_maxW
integer render_screenH,render_maxH
integer render_bytesPerPixel,render_clipping
atom flat_numlines,flat_y,flat_scraddr,flat_color,flat_code
atom mixflat_numlines,mixflat_y,mixflat_scraddr,mixflat_color,mixflat_code
global atom gouraud_scan_routine,gouraud_scan_data,gouraud_hlines,gouraud_y,gouraud_numlines,
            gouraud_scraddr,gouraud_code
atom mixgouraud_numlines,mixgouraud_y,mixgouraud_scraddr,mixgouraud_hlines
atom texture_numlines,texture_y,texture_scraddr,texture_texture,texture_code
atom mixtexture_numlines,mixtexture_y,mixtexture_scraddr,mixtexture_texture,mixtexture_code
atom tiledtexture_numlines,tiledtexture_y,tiledtexture_scraddr,tiledtexture_texture,tiledtexture_code
atom rMixTb
sequence mapping

mapping = {0,0,0,0,0}

procedure poke_word(atom dest,object word)
 if sequence(word) then
  for i=1 to length(word) do
   poke(dest+((i-1)*2),and_bits(word[i],#00FF))
   poke(dest+((i-1)*2)+1,floor(and_bits(word[i],#FF00)/256))
  end for
 else
  poke(dest,and_bits(word,#00FF))
  poke(dest+1,floor(and_bits(word,#FF00)/256))
 end if
end procedure

function peek_word(atom src)
integer ret
 ret=peek(src+1)*256
 ret=or_bits(ret,peek(src))
 return ret
end function

procedure poke3(atom dest,object word)
 if sequence(word) then
  for i=1 to length(word) do
   poke(dest+((i-1)*2),and_bits(word[i],#00FF))
   poke(dest+((i-1)*2)+1,floor(and_bits(word[i],#FF00)/256))
   poke(dest+((i-1)*2)+2,floor(and_bits(word[i],#FF0000)/65536))
  end for
 else
  poke(dest,and_bits(word,#00FF))
  poke(dest+1,floor(and_bits(word,#FF00)/256))
  poke(dest+2,floor(and_bits(word,#FF0000)/65536))
 end if
end procedure

function peek3(atom src)
integer ret
 ret = peek(src+2)*65536
 ret = or_bits(ret,peek(src+1)*256)
 ret = or_bits(ret,peek(src))
 return ret
end function





global function tile_texture(sequence tex,integer bpp)
integer bytesPP,dst
atom Tiled
 bytesPP=floor((bpp+1)/8)
 Tiled=allocate((256*256*bytesPP))
 if Tiled<=0 then
  return -1
 end if
 if bytesPP=1 then
  for v=0 to 255 do
   for u=0 to 255 do
    dst=and_bits((u*256),#F800)+and_bits(u,7)+and_bits((v*8),#07F8)
    poke(Tiled+dst,peek(tex[1]+(v*256)+u))
   end for
  end for
 elsif bytesPP=2 then
  for v=0 to 255 do
   for u=0 to 255 do
    dst=and_bits((u*256),#F800)+and_bits(u,7)+and_bits((v*8),#07F8)
    poke_word(Tiled+(dst*2),peek_word(tex[1]+(v*512)+(u*2)))
   end for
  end for
 elsif bytesPP=3 then
  for v=0 to 255 do
   for u=0 to 255 do
    dst=and_bits((u*256),#F800)+and_bits(u,7)+and_bits((v*8),#07F8)
    poke3(Tiled+(dst*3),peek3(tex[1]+(v*768)+(u*3)))
   end for
  end for
 end if
 free(tex[1])
 return {Tiled,tex[2],tex[3]}
end function


global procedure clear_area(atom dest,integer col,sequence coords)
integer len
 len=((coords[2][1]-coords[1][1])+1)*render_bytesPerPixel
 for i=coords[1][2] to coords[2][2] do
  mem_set(dest+(i*render_screenW*render_bytesPerPixel)+(coords[1][1]*render_bytesPerPixel),col,len)
 end for
end procedure


constant cls_code=get_asm(
"pusha cld "&
"mov edi,cls_dest "&
"mov eax,cls_col "&
"mov ecx,[cls_iterations] "&
"rep stosd "&
"popa ret")
constant cls_dest = cls_code+get_param("cls_dest")
constant cls_col = cls_code+get_param("cls_col")
resolve_param("cls_iterations",rClsIter)

global procedure cls(atom dest,integer col)
 poke4(cls_dest,dest)
 if render_bytesPerPixel=1 then
  poke(cls_col,{col,col,col,col})
 elsif render_bytesPerPixel=2 then
  poke_word(cls_col,{col,col})
 else
  poke4(cls_col,col)
 end if
 call(cls_code)
end procedure









--!!!!! U.D !!!!!


--STRUCT poly_data=
-- {
--  DWORD *vp1,*vp2,*vp3,*vp4
--  DWORD x[4]
--  DWORD y[4]
--  DWORD color
--  DWORD delta_x[4]
--  DWORD delta_y[4]
--  DWORD d[4]
--  DWORD *horizline_proc 
-- }
global constant poly_data=allocate(400)


global constant drawsection8=get_asm(
"mov eax,[start_y] "&
"cmp eax,[maxH] "&
"jng ds8_@y1_ok "&
  "ret "&
"ds8_@y1_ok: "&

"mov ecx,[end_y] "&
"cmp ecx,0 "&
"jge ds8_@y2_ok "&
  "ret "&
"ds8_@y2_ok: "&

"cmp eax,0 "&
"jge ds8_@y1_ok_2 "&
  "neg eax mov ebx,eax "&
  "mov eax,[dxdy_1] "&
  "imul ebx "&
  "add [x1],eax "&
  "mov eax,[dxdy_2] "&
  "imul ebx "&
  "add [x2],eax "& 
  "xor eax,eax "&
"ds8_@y1_ok_2: "&

"cmp ecx,[maxH] "&
"jng ds8_@y2_ok_2 "&
  "mov ecx,[maxH] "&
"ds8_@y2_ok_2: "&

"sub ecx,eax "&
"inc ecx "&
"cmp ecx,0 "&
"jg ds8_@height_ok "&
  "ret "&
"ds8_@height_ok: "&

"mul dword ptr [screenW] "&
"add edi,eax "&					-- edi = dest+(y*screenW)

"mov edx,[x1] "&
"mov esi,[x2] "&
"ds8_@yloop: "&
  "mov ebp,edx "&
  "mov ebx,esi "&

  "sar ebp,9 "&
  "sar ebx,9 "&
  "cmp ebp,ebx "&					
  "jng @@x1_ng_x2 "&				
    "xchg ebp,ebx "&				
  "@@x1_ng_x2: "&				

  "cmp ebp,[maxW] "&
  "jg @@yloop_next "&
  "cmp ebx,0 "&
  "jl @@yloop_next "&

  "push edi "&
  "push ecx "&

  "cmp ebp,0 "&
  "jge ds8_@x1_nl_zero "&
    "xor ebp,ebp "&
  "ds8_@x1_nl_zero: "&

  "cmp ebx,[maxW] "&
  "jng ds8_@x2_ng_maxW "&
    "mov ebx,[maxW] "&
  "ds8_@x2_ng_maxW: "&

  "mov ecx,ebx "&
  "sub ecx,ebp "&
  "inc ecx "&
  "add edi,ebp "&					-- edi += x1

  "mov ebp,ecx "&
  "and ebp,3 "&
  "shr ecx,2 "&
  "mov eax,[tri_color] "&
  "rep stosd "&                         -- draw floor(ecx/4) groups of 4 pixels
  "mov ecx,ebp "&
  "rep stosb "&                         -- draw remaining pixels

  "pop ecx "&
  "pop edi "&
  "@@yloop_next: "&
  "dec ecx "&
  "jz @@yloop_done "&
  "add edi,[screenW] "&
  "add edx,[dxdy_1] "&
  "add esi,[dxdy_2] "&
"jmp ds8_@yloop "&
"@@yloop_done: "&
"mov [x2],esi "&
"ret")
resolve_param("dxdy_1",poly_data+64)
resolve_param("dxdy_2",poly_data+68)
resolve_param("tri_color",poly_data+76)
resolve_param("start_y",poly_data+112)
resolve_param("end_y",poly_data+120)
resolve_param("x1",poly_data+128)
resolve_param("x2",poly_data+132)
resolve_param("maxH",rMaxH)
resolve_param("maxW",rMaxW)
resolve_param("screenW",rScreenW)


global constant drawgouraudsection8=get_asm(
"mov eax,[start_y] "&
"cmp eax,[maxH] "&
"jng @@y1_ok "&
  "ret "&
"@@y1_ok: "&

"mov ecx,[end_y] "&
"cmp ecx,0 "&
"jge @@y2_ok "&
  "ret "&
"@@y2_ok: "&

"cmp eax,0 "&
"jge @@y1_ok_2 "&
  "mov ebx,0 "&
  "sub ebx,eax "&
  "mov eax,[dxdy_1] "&
  "imul ebx "&
  "add [x1],eax "&
  "mov eax,[dxdy_2] "&
  "imul ebx "&
  "add [x2],eax "&
  "mov eax,[dcdy_1] "&
  "imul ebx "&
  "add [c1],eax "&
  "mov eax,[dcdy_2] "&
  "imul ebx "&
  "add [c2],eax "&
  "xor eax,eax "&
"@@y1_ok_2: "&

"cmp ecx,[maxH] "&
"jng @@y2_ok_2 "&
  "mov ecx,[maxH] "&
"@@y2_ok_2: "&

"sub ecx,eax "&
"inc ecx "&
"mul dword ptr [screenW] "&
"add edi,eax "&					-- edi = dest+(y*screenW)

"@@yloop: "&
  "mov ebp,[x1] "&
  "mov ebx,[x2] "&
  "sar ebp,8 "&
  "sar ebx,8 "&

  "mov eax,[c1] "&
  "mov edx,[c2] "&
  "cmp ebp,ebx "&
  "jng @@x1_ng_x2 "&
    "xchg ebp,ebx "&
    "xchg eax,edx "&
  "@@x1_ng_x2: "&
  "mov [c1_2],eax "&
  "mov [c2_2],edx "&

  "cmp ebp,[maxW] "&
  "jg @@yloop_next "&
  "cmp ebx,0 "&
  "jl @@yloop_next "&

  "push edi "&
  "push ecx "&

  "mov ecx,ebx "&
  "sub ecx,ebp "&

  -- prevent a division-by-zero:
  "mov edx,0 "&
  "or ecx,ecx "&
  "setz dl "&
  "or ecx,edx "&

  "mov eax,[c2_2] "&
  "sub eax,[c1_2] "&
  "sar eax,1 "&
  -- 102,153 = CWD  (asm.e's cwd=cdq)
  "db 102 db 153 "&
  "idiv cx "&
  "movsx esi,ax "&
  "sal esi,1 "&

  "cmp ebp,0 "&
  "jge @@x1_nl_zero "&
    "mov eax,0 "&
    "sub eax,ebp "&
    "imul esi "&
    "add [c1_2],eax "&
    "mov ebp,0 "&
  "@@x1_nl_zero: "&

  "cmp ebx,[maxW] "&
  "jng @@x2_ng_maxW "&
    "mov ebx,[maxW] "&
  "@@x2_ng_maxW: "&

  "mov ecx,ebx "&
  "sub ecx,ebp "&
  "inc ecx "&
  "add edi,ebp "&
  "mov eax,[c1_2] "&

  "add edi,ecx "&
  "xor ecx,-1 "&
  "inc ecx "&

  "@@xloop: "&
   "mov [edi + ecx],ah "&
   "inc ecx "&
   -- LEA doesn't affect any flags, so it's safe to use it after INC ECX
   "lea eax,[eax+esi] "&
  "jnz @@xloop "&

  "pop ecx "&
  "pop edi "&
  "@@yloop_next: "&
  "dec ecx "&
  "jz @@yloop_done "&
  "add edi,[screenW] "&
  "mov eax,[dxdy_1] "&
  "mov ebx,[dxdy_2] "&
  "add [x1],eax "&
  "add [x2],ebx "&
  "mov eax,[dcdy_1] "&
  "mov ebx,[dcdy_2] "&
  "add [c1],eax "&
  "add [c2],ebx "&

"jmp near @@yloop "&
"@@yloop_done: "&
"ret")
resolve_param("dxdy_1",poly_data+64)
resolve_param("dxdy_2",poly_data+68)
resolve_param("dcdy_1",poly_data+184)
resolve_param("dcdy_2",poly_data+188)
resolve_param("start_y",poly_data+112)
resolve_param("end_y",poly_data+120)
resolve_param("x1",poly_data+128)
resolve_param("x2",poly_data+132)
resolve_param("c1",poly_data+192)
resolve_param("c2",poly_data+196)
resolve_param("c1_2",poly_data+200)
resolve_param("c2_2",poly_data+204)
resolve_param("maxH",rMaxH)
resolve_param("maxW",rMaxW)
resolve_param("screenW",rScreenW)



global constant drawsection1516=get_asm(
"mov eax,[start_y] "&
"cmp eax,[maxH] "&
"jng @@y1_ok "&
  "ret "&
"@@y1_ok: "&

"mov ecx,[end_y] "&
"cmp ecx,0 "&
"jge @@y2_ok "&
  "ret "&
"@@y2_ok: "&

"cmp eax,0 "&
"jge @@y1_ok_2 "&
  "neg eax "&
  "mov ebx,eax "&
  "mov eax,[dxdy_1] "&
  "imul ebx "&
  "add [x1],eax "&
  "mov eax,[dxdy_2] "&
  "imul ebx "&
  "add [x2],eax "& 
  "xor eax,eax "&
"@@y1_ok_2: "&

"cmp ecx,[maxH] "&
"jng @@y2_ok_2 "&
  "mov ecx,[maxH] "&
"@@y2_ok_2: "&

"sub ecx,eax "&
"inc ecx "&
"cmp ecx,0 "&
"jg @@height_ok "&
  "ret "&
"@@height_ok: "&

"mul dword ptr [screenW] "&
"lea edi,[eax*2 + edi] "&					-- edi = dest+(y*screenW)

"mov edx,[x1] "&
"mov esi,[x2] "&
"@@yloop: "&
  "mov ebp,edx "&
  "mov ebx,esi "&

  "sar ebp,9 "&
  "sar ebx,9 "&
  "cmp ebp,ebx "&					
  "jng @@x1_ng_x2 "&				
    "xchg ebp,ebx "&				
  "@@x1_ng_x2: "&				

  "cmp ebp,[maxW] "&
  "jg @@yloop_next "&
  "cmp ebx,0 "&
  "jl @@yloop_next "&

  "push edi "&
  "push ecx "&

  "cmp ebp,0 "&
  "jge @@x1_nl_zero "&
    "xor ebp,ebp "&
  "@@x1_nl_zero: "&

  "cmp ebx,[maxW] "&
  "jng @@x2_ng_maxW "&
    "mov ebx,[maxW] "&
  "@@x2_ng_maxW: "&

  "mov ecx,ebx "&
  "sub ecx,ebp "&
  "inc ecx "&
  "add edi,ebp "&					-- edi += x1
  "add edi,ebp "&					-- edi += x1
  "mov ebp,ecx "&
  "and ebp,1 "&
  "shr ecx,1 "&
  "mov eax,[tri_color] "&
  "rep stosd "&
  "mov ecx,ebp "&
  "rep stosw "&

  "pop ecx "&
  "pop edi "&
  "@@yloop_next: "&
  "dec ecx "&
  "jz @@yloop_done "&
  "add edi,[screenW] "&
  "add edi,[screenW] "&
  "add edx,[dxdy_1] "&
  "add esi,[dxdy_2] "&
"jmp @@yloop "&
"@@yloop_done: "&
"mov [x2],esi "&
"ret")
resolve_param("dxdy_1",poly_data+64)
resolve_param("dxdy_2",poly_data+68)
resolve_param("tri_color",poly_data+76)
resolve_param("start_y",poly_data+112)
resolve_param("end_y",poly_data+120)
resolve_param("x1",poly_data+128)
resolve_param("x2",poly_data+132)
resolve_param("maxH",rMaxH)
resolve_param("maxW",rMaxW)
resolve_param("screenW",rScreenW)


global constant drawsection24=get_asm(
"mov eax,[start_y] "&
"cmp eax,[maxH] "&
"jng @@y1_ok "&
  "ret "&
"@@y1_ok: "&

"mov ecx,[end_y] "&
"cmp ecx,0 "&
"jge @@y2_ok "&
  "ret "&
"@@y2_ok: "&

"cmp eax,0 "&
"jge @@y1_ok_2 "&
  "neg eax mov ebx,eax "&
  "mov eax,[dxdy_1] "&
  "imul ebx "&
  "add [x1],eax "&
  "mov eax,[dxdy_2] "&
  "imul ebx "&
  "add [x2],eax "& 
  "xor eax,eax "&
"@@y1_ok_2: "&

"cmp ecx,[maxH] "&
"jng @@y2_ok_2 "&
  "mov ecx,[maxH] "&
"@@y2_ok_2: "&

"sub ecx,eax "&
"inc ecx "&
"cmp ecx,0 "&
"jg @@height_ok "&
  "ret "&
"@@height_ok: "&

"mul dword ptr [screenW] "&
"lea eax,[eax*2 + eax] "&					-- edi = dest+(y*screenW)
"add edi,eax "&

"mov edx,[x1] "&
"mov esi,[x2] "&
"@@yloop: "&
  "mov ebp,edx "&
  "mov ebx,esi "&

  "sar ebp,9 "&
  "sar ebx,9 "&
  "cmp ebp,ebx "&					
  "jng @@x1_ng_x2 "&				
    "xchg ebp,ebx "&				
  "@@x1_ng_x2: "&				

  "cmp ebp,[maxW] "&
  "jg @@yloop_next "&
  "cmp ebx,0 "&
  "jl @@yloop_next "&

  "push edi "&
  "push ecx "&

  "cmp ebp,0 "&
  "jge @@x1_nl_zero "&
    "xor ebp,ebp "&
  "@@x1_nl_zero: "&

  "cmp ebx,[maxW] "&
  "jng @@x2_ng_maxW "&
    "mov ebx,[maxW] "&
  "@@x2_ng_maxW: "&

  "mov ecx,ebx "&
  "sub ecx,ebp "&
  "inc ecx "&
  "add edi,ebp "&					-- edi += x1
  "mov ax,[tri_color] "&
  "add edi,ebp "&					-- edi += x1
  "add edi,ebp "&					-- edi += x1
  "lea ebp,[ecx*2 + ecx] "&
  "add edi,ebp "&
  "mov bl,[tri_color+2] "&
  "xor ecx,-1 "&
  "inc ecx "&
   
  "@@xloop: "&
   "lea ebp,[ecx*2 + ecx] "& 
   "mov [edi + ebp],ax "&
   "add ebp,2 "&
   "inc ecx "&
   "mov [edi + ebp],bl "&
  "jnz @@xloop "&  

  "pop ecx "&
  "pop edi "&
  "@@yloop_next: "&
  "dec ecx "&
  "jz @@yloop_done "&
  "add edi,[screenW] "&
  "add edi,[screenW] "&
  "add edi,[screenW] "&
  "add edx,[dxdy_1] "&
  "add esi,[dxdy_2] "&
"jmp near @@yloop "&
"@@yloop_done: "&
"mov [x2],esi "&
"ret")
resolve_param("dxdy_1",poly_data+64)
resolve_param("dxdy_2",poly_data+68)
resolve_param("tri_color",poly_data+76)
resolve_param("start_y",poly_data+112)
resolve_param("end_y",poly_data+120)
resolve_param("x1",poly_data+128)
resolve_param("x2",poly_data+132)
resolve_param("maxH",rMaxH)
resolve_param("maxW",rMaxW)
resolve_param("screenW",rScreenW)




global constant drawgouraudsection15=get_asm(
"mov eax,[start_y] "&
"cmp eax,[maxH] "&
"jng @@y1_ok "&
  "ret "&
"@@y1_ok: "&

"mov ecx,[end_y] "&
"cmp ecx,0 "&
"jge @@y2_ok "&
  "ret "&
"@@y2_ok: "&

"cmp eax,0 "&
"jge @@y1_ok_2 "&
  "mov ebx,0 "&
  "sub ebx,eax "&
  "mov eax,[dxdy_1] "&
  "imul ebx "&
  "add [x1],eax "&
  "mov eax,[dxdy_2] "&
  "imul ebx "&
  "add [x2],eax "&
  "mov eax,[drdy_1] "&
  "imul ebx "&
  "add [r1],eax "&
  "mov eax,[drdy_2] "&
  "imul ebx "&
  "add [r2],eax "&
  "mov eax,[dgdy_1] "&
  "imul ebx "&
  "add [g1],eax "&
  "mov eax,[dgdy_2] "&
  "imul ebx "&
  "add [g2],eax "&
  "mov eax,[dbdy_1] "&
  "imul ebx "&
  "add [b1],eax "&
  "mov eax,[dbdy_2] "&
  "imul ebx "&
  "add [b2],eax "&
  "xor eax,eax "&
"@@y1_ok_2: "&

"cmp ecx,[maxH] "&
"jng @@y2_ok_2 "&
  "mov ecx,[maxH] "&
"@@y2_ok_2: "&

"sub ecx,eax "&
"inc ecx "&
"mul dword ptr [screenW] "&
"lea edi,[eax*2 + edi] "&					-- edi = dest+(y*screenW)

"@@yloop: "&
  "mov ebp,[x1] "&
  "mov ebx,[x2] "&
  "sar ebp,9 "&
  "sar ebx,9 "&

  "mov eax,0 "&
  "mov edx,4 "&
  "cmp ebp,ebx "&
  "jng @@x1_ng_x2 "&
    "xchg ebp,ebx "&
    "xchg eax,edx "&
  "@@x1_ng_x2: "&
  "mov esi,[r1] "&
  "mov [r1_2+eax],esi "&
  "mov esi,[r2] "&
  "mov [r1_2+edx],esi "&
  "mov esi,[g1] "&
  "mov [g1_2+eax],esi "&
  "mov esi,[g2] "&
  "mov [g1_2+edx],esi "&
  "mov esi,[b1] "&
  "mov [b1_2+eax],esi "&
  "mov esi,[b2] "&
  "mov [b1_2+edx],esi "&

  "cmp ebp,[maxW] "&
  "jg near @@yloop_next "&
  "cmp ebx,0 "&
  "jl near @@yloop_next "&

  "push edi "&
  "push ecx "&

  "mov ecx,ebx "&
  "sub ecx,ebp "&
  "or ecx,ecx "&
  "setz dl "&
  "or cl,dl "&
  "mov eax,[r2_2] "&
  "sub ax,[r1_2] "&
  "db 102 db 153 "&     -- 102,153 = [C]onvert_[W]ord_to_[D]oubleword
  "idiv cx "&
  "movsx eax,ax "&
  "mov [d_r],eax "&
  "mov eax,[g2_2] "&
  "sub ax,[g1_2] "&
  "db 102 db 153 "&
  "idiv cx "&
  "movsx eax,ax "&
  "mov [d_g],eax "&
  "mov eax,[b2_2] "&
  "sub ax,[b1_2] "&
  "db 102 db 153 "&
  "idiv cx "&
  "movsx eax,ax "&
  "mov [d_b],eax "&

  "cmp ebp,0 "&
  "jge @@x1_nl_zero "&
    "mov esi,0 "&
    "sub esi,ebp "&
    "mov eax,[d_r] "&
    "imul esi "&
    "add [r1_2],eax "&
    "mov eax,[d_g] "&
    "imul esi "&
    "add [g1_2],eax "&
    "mov eax,[d_b] "&
    "imul esi "&
    "add [b1_2],eax "&
    "mov ebp,0 "&
  "@@x1_nl_zero: "&

  "cmp ebx,[maxW] "&
  "jng @@x2_ng_maxW "&
    "mov ebx,[maxW] "&
  "@@x2_ng_maxW: "&

  "mov ecx,ebx "&
  "sub ecx,ebp "&
  "inc ecx "&
  "add edi,ebp "&
  "add edi,ebp "&

  "lea edi,[ecx*2 + edi] "&
  "xor ecx,-1 "&
  "inc ecx "&

  "mov ebx,[b1_2] "&
  "mov ebp,[g1_2] "&
  "mov esi,[r1_2] "&
 
  "@@xloop: "&
   "mov eax,ebx "&      -- 000bbbbb xxxxxxxx
   "mov edx,ebp "&      -- 000ggggg xxxxxxxx
   "shr eax,5 "&        -- 00000000 bbbbbxxx
   "and edx,7936 "&     -- 000ggggg 00000000
   "or eax,edx "&       -- 000ggggg bbbbbxxx
   "mov edx,esi "&      -- 0rrrrrxx xxxxxxxx
   "shr eax,3 "&        -- 000000gg gggbbbbb
   "and edx,31744 "&    -- 0rrrrr00 00000000
   "or eax,edx "&       -- 0rrrrrgg gggbbbbb
   "mov [edi+ecx*2],ax "&
   "inc ecx "&
   "jz @@xloop_done "&
   "add ebx,[d_b] "&
   "add ebp,[d_g] "&
   "add esi,[d_r] "&
  "jmp @@xloop "&
  "@@xloop_done: "&

  "pop ecx "&
  "pop edi "&
  "@@yloop_next: "&
  "dec ecx "&
  "jz @@yloop_done "&
  "add edi,[screenW] "&
  "add edi,[screenW] "&
  "mov eax,[dxdy_1] "&
  "mov ebx,[dxdy_2] "&
  "add [x1],eax "&
  "add [x2],ebx "&
  "mov eax,[drdy_1] "&
  "mov ebx,[drdy_2] "&
  "add [r1],eax "&
  "add [r2],ebx "&
  "mov eax,[dgdy_1] "&
  "mov ebx,[dgdy_2] "&
  "add [g1],eax "&
  "add [g2],ebx "&
  "mov eax,[dbdy_1] "&
  "mov ebx,[dbdy_2] "&
  "add [b1],eax "&
  "add [b2],ebx "&
"jmp near @@yloop "&
"@@yloop_done: "&
"ret")
resolve_param("dxdy_1",poly_data+64)
resolve_param("dxdy_2",poly_data+68)
resolve_param("start_y",poly_data+112)
resolve_param("end_y",poly_data+120)
resolve_param("x1",poly_data+128)
resolve_param("x2",poly_data+132)
resolve_param("maxH",rMaxH)
resolve_param("maxW",rMaxW)
resolve_param("screenW",rScreenW)
resolve_param("drdy_1",poly_data+232)
resolve_param("drdy_2",poly_data+236)
resolve_param("dgdy_1",poly_data+240)
resolve_param("dgdy_2",poly_data+244)
resolve_param("dbdy_1",poly_data+248)
resolve_param("dbdy_2",poly_data+252)
resolve_param("r1",poly_data+256)
resolve_param("g1",poly_data+260)
resolve_param("b1",poly_data+264)
resolve_param("r2",poly_data+268)
resolve_param("g2",poly_data+272)
resolve_param("b2",poly_data+276)
resolve_param("r1_2",poly_data+360)
resolve_param("r2_2",poly_data+364)
resolve_param("g1_2",poly_data+368)
resolve_param("g2_2",poly_data+372)
resolve_param("b1_2",poly_data+376)
resolve_param("b2_2",poly_data+380)
resolve_param("d_r",poly_data+384)
resolve_param("d_g",poly_data+388)
resolve_param("d_b",poly_data+392)



global constant drawgouraudsection16=get_asm(
"mov eax,[start_y] "&
"cmp eax,[maxH] "&
"jng @@y1_ok "&
  "ret "&
"@@y1_ok: "&

"mov ecx,[end_y] "&
"cmp ecx,0 "&
"jge @@y2_ok "&
  "ret "&
"@@y2_ok: "&

"cmp eax,0 "&
"jge @@y1_ok_2 "&
  "mov ebx,0 "&
  "sub ebx,eax "&
  "mov eax,[dxdy_1] "&
  "imul ebx "&
  "add [x1],eax "&
  "mov eax,[dxdy_2] "&
  "imul ebx "&
  "add [x2],eax "&
  "mov eax,[drdy_1] "&
  "imul ebx "&
  "add [r1],eax "&
  "mov eax,[drdy_2] "&
  "imul ebx "&
  "add [r2],eax "&
  "mov eax,[dgdy_1] "&
  "imul ebx "&
  "add [g1],eax "&
  "mov eax,[dgdy_2] "&
  "imul ebx "&
  "add [g2],eax "&
  "mov eax,[dbdy_1] "&
  "imul ebx "&
  "add [b1],eax "&
  "mov eax,[dbdy_2] "&
  "imul ebx "&
  "add [b2],eax "&
  "xor eax,eax "&
"@@y1_ok_2: "&

"cmp ecx,[maxH] "&
"jng @@y2_ok_2 "&
  "mov ecx,[maxH] "&
"@@y2_ok_2: "&

"sub ecx,eax "&
"inc ecx "&
"mul dword ptr [screenW] "&
"lea edi,[eax*2 + edi] "&					-- edi = dest+(y*screenW)

"@@yloop: "&
  "mov ebp,[x1] "&
  "mov ebx,[x2] "&
  "sar ebp,9 "&
  "sar ebx,9 "&

  "mov eax,0 "&
  "mov edx,4 "&
  "cmp ebp,ebx "&
  "jng @@x1_ng_x2 "&
    "xchg ebp,ebx "&
    "xchg eax,edx "&
  "@@x1_ng_x2: "&
  "mov esi,[r1] "&
  "mov [r1_2+eax],esi "&
  "mov esi,[r2] "&
  "mov [r1_2+edx],esi "&
  "mov esi,[g1] "&
  "mov [g1_2+eax],esi "&
  "mov esi,[g2] "&
  "mov [g1_2+edx],esi "&
  "mov esi,[b1] "&
  "mov [b1_2+eax],esi "&
  "mov esi,[b2] "&
  "mov [b1_2+edx],esi "&

  "cmp ebp,[maxW] "&
  "jg near @@yloop_next "&
  "cmp ebx,0 "&
  "jl near @@yloop_next "&

  "push edi "&
  "push ecx "&

  "mov ecx,ebx "&
  "sub ecx,ebp "&
  "or ecx,ecx "&
  "setz dl "&
  "or cl,dl "&

  -- r uses the highest (the 15th) bit, that's why a 32-bit idiv is used here.
  "mov eax,[r2_2] "&
  "sub eax,[r1_2] "&
  "cwd "&
  "idiv ecx "&
  "mov [d_r],eax "&
  "mov eax,[g2_2] "&
  "sub ax,[g1_2] "&
  "db 102 db 153 "&
  "idiv cx "&
  "movsx eax,ax "&
  "mov [d_g],eax "&
  "mov eax,[b2_2] "&
  "sub ax,[b1_2] "&
  "db 102 db 153 "&
  "idiv cx "&
  "movsx eax,ax "&
  "mov [d_b],eax "&

  "cmp ebp,0 "&
  "jge @@x1_nl_zero "&
    "mov esi,0 "&
    "sub esi,ebp "&
    "mov eax,[d_r] "&
    "imul esi "&
    "add [r1_2],eax "&
    "mov eax,[d_g] "&
    "imul esi "&
    "add [g1_2],eax "&
    "mov eax,[d_b] "&
    "imul esi "&
    "add [b1_2],eax "&
    "mov ebp,0 "&
  "@@x1_nl_zero: "&

  "cmp ebx,[maxW] "&
  "jng @@x2_ng_maxW "&
    "mov ebx,[maxW] "&
  "@@x2_ng_maxW: "&

  "mov ecx,ebx "&
  "sub ecx,ebp "&
  "inc ecx "&
  "add edi,ebp "&
  "add edi,ebp "&

  "lea edi,[ecx*2 + edi] "&
  "xor ecx,-1 "&
  "inc ecx "&

  "mov ebx,[b1_2] "&
  "mov ebp,[g1_2] "&
  "mov esi,[r1_2] "&
 
  "@@xloop: "&
   "mov eax,ebx "&      -- 000bbbbb xxxxxxxx
   "mov edx,ebp "&      -- 00gggggg xxxxxxxx
   "shr eax,5 "&        -- 00000000 bbbbbxxx
   "and edx,16128 "&    -- 00gggggg 00000000
   "or eax,edx "&       -- 00gggggg bbbbbxxx
   "mov edx,esi "&      -- rrrrrxxx xxxxxxxx
   "shr eax,3 "&        -- 00000ggg gggbbbbb
   "and edx,63488 "&    -- rrrrr000 00000000
   "or eax,edx "&       -- rrrrrggg gggbbbbb
   "mov [edi+ecx*2],ax "&
   "inc ecx "&
   "jz @@xloop_done "&
   "add ebx,[d_b] "&
   "add ebp,[d_g] "&
   "add esi,[d_r] "&
  "jmp @@xloop "&
  "@@xloop_done: "&

  "pop ecx "&
  "pop edi "&
  "@@yloop_next: "&
  "dec ecx "&
  "jz @@yloop_done "&
  "add edi,[screenW] "&
  "add edi,[screenW] "&
  "mov eax,[dxdy_1] "&
  "mov ebx,[dxdy_2] "&
  "add [x1],eax "&
  "add [x2],ebx "&
  "mov eax,[drdy_1] "&
  "mov ebx,[drdy_2] "&
  "add [r1],eax "&
  "add [r2],ebx "&
  "mov eax,[dgdy_1] "&
  "mov ebx,[dgdy_2] "&
  "add [g1],eax "&
  "add [g2],ebx "&
  "mov eax,[dbdy_1] "&
  "mov ebx,[dbdy_2] "&
  "add [b1],eax "&
  "add [b2],ebx "&
"jmp near @@yloop "&
"@@yloop_done: "&
"ret")
resolve_param("dxdy_1",poly_data+64)
resolve_param("dxdy_2",poly_data+68)
resolve_param("start_y",poly_data+112)
resolve_param("end_y",poly_data+120)
resolve_param("x1",poly_data+128)
resolve_param("x2",poly_data+132)
resolve_param("maxH",rMaxH)
resolve_param("maxW",rMaxW)
resolve_param("screenW",rScreenW)
resolve_param("drdy_1",poly_data+232)
resolve_param("drdy_2",poly_data+236)
resolve_param("dgdy_1",poly_data+240)
resolve_param("dgdy_2",poly_data+244)
resolve_param("dbdy_1",poly_data+248)
resolve_param("dbdy_2",poly_data+252)
resolve_param("r1",poly_data+256)
resolve_param("g1",poly_data+260)
resolve_param("b1",poly_data+264)
resolve_param("r2",poly_data+268)
resolve_param("g2",poly_data+272)
resolve_param("b2",poly_data+276)
resolve_param("r1_2",poly_data+360)
resolve_param("r2_2",poly_data+364)
resolve_param("g1_2",poly_data+368)
resolve_param("g2_2",poly_data+372)
resolve_param("b1_2",poly_data+376)
resolve_param("b2_2",poly_data+380)
resolve_param("d_r",poly_data+384)
resolve_param("d_g",poly_data+388)
resolve_param("d_b",poly_data+392)



global constant drawgouraudsection24=get_asm(
"mov eax,[start_y] "&
"cmp eax,[maxH] "&
"jng @@y1_ok "&
  "ret "&
"@@y1_ok: "&

"mov ecx,[end_y] "&
"cmp ecx,0 "&
"jge @@y2_ok "&
  "ret "&
"@@y2_ok: "&

"cmp eax,0 "&
"jge @@y1_ok_2 "&
  "mov ebx,0 "&
  "sub ebx,eax "&
  "mov eax,[dxdy_1] "&
  "imul ebx "&
  "add [x1],eax "&
  "mov eax,[dxdy_2] "&
  "imul ebx "&
  "add [x2],eax "&
  "mov eax,[drdy_1] "&
  "imul ebx "&
  "add [r1],eax "&
  "mov eax,[drdy_2] "&
  "imul ebx "&
  "add [r2],eax "&
  "mov eax,[dgdy_1] "&
  "imul ebx "&
  "add [g1],eax "&
  "mov eax,[dgdy_2] "&
  "imul ebx "&
  "add [g2],eax "&
  "mov eax,[dbdy_1] "&
  "imul ebx "&
  "add [b1],eax "&
  "mov eax,[dbdy_2] "&
  "imul ebx "&
  "add [b2],eax "&
  "xor eax,eax "&
"@@y1_ok_2: "&

"cmp ecx,[maxH] "&
"jng @@y2_ok_2 "&
  "mov ecx,[maxH] "&
"@@y2_ok_2: "&

"sub ecx,eax "&
"inc ecx "&
"mul dword ptr [screenW] "&
"lea eax,[eax*2 + eax] "&					-- edi = dest+(y*screenW)
"add edi,eax "&

"@@yloop: "&
  "mov ebp,[x1] "&
  "mov ebx,[x2] "&
  "sar ebp,9 "&
  "sar ebx,9 "&

  "mov eax,0 "&
  "mov edx,4 "&
  "cmp ebp,ebx "&
  "jng @@x1_ng_x2 "&
    "xchg ebp,ebx "&
    "xchg eax,edx "&
  "@@x1_ng_x2: "&
  "mov esi,[r1] "&
  "mov [r1_2+eax],esi "&
  "mov esi,[r2] "&
  "mov [r1_2+edx],esi "&
  "mov esi,[g1] "&
  "mov [g1_2+eax],esi "&
  "mov esi,[g2] "&
  "mov [g1_2+edx],esi "&
  "mov esi,[b1] "&
  "mov [b1_2+eax],esi "&
  "mov esi,[b2] "&
  "mov [b1_2+edx],esi "&

  "cmp ebp,[maxW] "&
  "jg near @@yloop_next "&
  "cmp ebx,0 "&
  "jl near @@yloop_next "&

  "push edi "&
  "push ecx "&

  "mov ecx,ebx "&
  "sub ecx,ebp "&
  "or ecx,ecx "&
  "setz dl "&
  "or cl,dl "&
  "mov eax,[r2_2] "&
  "sub eax,[r1_2] "&
  "cwd "&
  "idiv ecx "&
  "mov [d_r],eax "&
  "mov eax,[g2_2] "&
  "sub eax,[g1_2] "&
  "cwd "&
  "idiv ecx "&
  "mov [d_g],eax "&
  "mov eax,[b2_2] "&
  "sub eax,[b1_2] "&
  "cwd "&
  "idiv ecx "&
  "mov [d_b],eax "&

  "cmp ebp,0 "&
  "jge @@x1_nl_zero "&
    "mov esi,0 "&
    "sub esi,ebp "&
    "mov eax,[d_r] "&
    "imul esi "&
    "add [r1_2],eax "&
    "mov eax,[d_g] "&
    "imul esi "&
    "add [g1_2],eax "&
    "mov eax,[d_b] "&
    "imul esi "&
    "add [b1_2],eax "&
    "mov ebp,0 "&
  "@@x1_nl_zero: "&

  "cmp ebx,[maxW] "&
  "jng @@x2_ng_maxW "&
    "mov ebx,[maxW] "&
  "@@x2_ng_maxW: "&

  "mov ecx,ebx "&
  "sub ecx,ebp "&
  "inc ecx "&
  "add edi,ebp "&
  "add edi,ebp "&
  "add edi,ebp "&

  "lea edi,[ecx*2 + edi] "&
  "add edi,ecx "&
  "xor ecx,-1 "&
  "inc ecx "&

  "mov ebx,[b1_2] "&
  "mov ebp,[g1_2] "&
  "mov esi,[r1_2] "&
 
  "@@xloop: "&
   "mov eax,ebx "&      -- 00000000 bbbbbbbb xxxxxxxx
   "mov edx,ebp "&      -- 00000000 gggggggg xxxxxxxx
   "shr eax,8 "&        -- 00000000 00000000 bbbbbbbb
   "and edx,65280 "&    -- 00000000 gggggggg 00000000
   "or eax,edx "&       -- 00000000 gggggggg bbbbbbbb
   "lea edx,[ecx*2 + ecx] "&
   "mov [edi+edx],ax "&
   "add edx,2 "&
   "mov eax,esi "&
   "mov [edi+edx],ah "&
   "inc ecx "&
   "jz @@xloop_done "&
   "add ebx,[d_b] "&
   "add ebp,[d_g] "&
   "add esi,[d_r] "&
  "jmp @@xloop "&
  "@@xloop_done: "&

  "pop ecx "&
  "pop edi "&
  "@@yloop_next: "&
  "dec ecx "&
  "jz @@yloop_done "&
  "add edi,[screenW] "&
  "add edi,[screenW] "&
  "add edi,[screenW] "&
  "mov eax,[dxdy_1] "&
  "mov ebx,[dxdy_2] "&
  "add [x1],eax "&
  "add [x2],ebx "&
  "mov eax,[drdy_1] "&
  "mov ebx,[drdy_2] "&
  "add [r1],eax "&
  "add [r2],ebx "&
  "mov eax,[dgdy_1] "&
  "mov ebx,[dgdy_2] "&
  "add [g1],eax "&
  "add [g2],ebx "&
  "mov eax,[dbdy_1] "&
  "mov ebx,[dbdy_2] "&
  "add [b1],eax "&
  "add [b2],ebx "&
"jmp near @@yloop "&
"@@yloop_done: "&
"ret")
resolve_param("dxdy_1",poly_data+64)
resolve_param("dxdy_2",poly_data+68)
resolve_param("start_y",poly_data+112)
resolve_param("end_y",poly_data+120)
resolve_param("x1",poly_data+128)
resolve_param("x2",poly_data+132)
resolve_param("maxH",rMaxH)
resolve_param("maxW",rMaxW)
resolve_param("screenW",rScreenW)
resolve_param("drdy_1",poly_data+232)
resolve_param("drdy_2",poly_data+236)
resolve_param("dgdy_1",poly_data+240)
resolve_param("dgdy_2",poly_data+244)
resolve_param("dbdy_1",poly_data+248)
resolve_param("dbdy_2",poly_data+252)
resolve_param("r1",poly_data+256)
resolve_param("g1",poly_data+260)
resolve_param("b1",poly_data+264)
resolve_param("r2",poly_data+268)
resolve_param("g2",poly_data+272)
resolve_param("b2",poly_data+276)
resolve_param("r1_2",poly_data+360)
resolve_param("r2_2",poly_data+364)
resolve_param("g1_2",poly_data+368)
resolve_param("g2_2",poly_data+372)
resolve_param("b1_2",poly_data+376)
resolve_param("b2_2",poly_data+380)
resolve_param("d_r",poly_data+384)
resolve_param("d_g",poly_data+388)
resolve_param("d_b",poly_data+392)




global constant drawtexturesection8=get_asm(
"mov eax,[start_y] "&
"cmp eax,[maxH] "&
"jng @@y1_ok "&
  "ret "&
"@@y1_ok: "&

"mov ecx,[end_y] "&
"cmp ecx,0 "&
"jge @@y2_ok "&
  "ret "&
"@@y2_ok: "&

"cmp eax,0 "&
"jge @@y1_ok_2 "&
  "mov ebx,0 "&
  "sub ebx,eax "&
  "mov eax,[dxdy_1] "&
  "imul ebx "&
  "add [x1],eax "&
  "mov eax,[dxdy_2] "&
  "imul ebx "&
  "add [x2],eax "&
  "mov eax,[dudy_1] "&
  "imul ebx "&
  "add [u1],eax "&
  "mov eax,[dudy_2] "&
  "imul ebx "&
  "add [u2],eax "&
  "mov eax,[dvdy_1] "&
  "imul ebx "&
  "add [v1],eax "&
  "mov eax,[dvdy_2] "&
  "imul ebx "&
  "add [v2],eax "&
  "xor eax,eax "&
"@@y1_ok_2: "&

"cmp ecx,[maxH] "&
"jng @@y2_ok_2 "&
  "mov ecx,[maxH] "&
"@@y2_ok_2: "&

"sub ecx,eax "&
"inc ecx "&
"mul dword ptr [screenW] "&
"add edi,eax "&

"@@yloop: "&
  "mov ebp,[x1] "&
  "mov ebx,[x2] "&
  "sar ebp,9 "&
  "sar ebx,9 "&

  "mov eax,0 "&
  "mov edx,4 "&
  "cmp ebp,ebx "&
  "jng @@x1_ng_x2 "&
    "xchg ebp,ebx "&
    "xchg eax,edx "&
  "@@x1_ng_x2: "&
  "mov esi,[u1] "&
  "mov [u1_2+eax],esi "&
  "mov esi,[u2] "&
  "mov [u1_2+edx],esi "&
  "mov esi,[v1] "&
  "mov [v1_2+eax],esi "&
  "mov esi,[v2] "&
  "mov [v1_2+edx],esi "&

  "cmp ebp,[maxW] "&
  "jg near @@yloop_next "&
  "cmp ebx,0 "&
  "jl near @@yloop_next "&

  "push edi "&
  "push ecx "&

  "mov ecx,ebx "&
  "sub ecx,ebp "&
  "or ecx,ecx "&
  "setz dl "&
  "or cl,dl "&
  "mov eax,[u2_2] "&
  "sub eax,[u1_2] "&
  "cwd "&
  "idiv ecx "&
  "mov [d_u],eax "&
  "mov eax,[v2_2] "&
  "sub eax,[v1_2] "&
  "cwd "&
  "idiv ecx "&
  "mov [d_v],eax "&

  "cmp ebp,0 "&
  "jge @@x1_nl_zero "&
    "mov esi,0 "&
    "sub esi,ebp "&
    "mov eax,[d_u] "&
    "imul esi "&
    "add [u1_2],eax "&
    "mov eax,[d_v] "&
    "imul esi "&
    "add [v1_2],eax "&
    "mov ebp,0 "&
  "@@x1_nl_zero: "&

  "cmp ebx,[maxW] "&
  "jng @@x2_ng_maxW "&
    "mov ebx,[maxW] "&
  "@@x2_ng_maxW: "&

  "mov ecx,ebx "&
  "sub ecx,ebp "&
  "inc ecx "&
  "add edi,ebp "&

  "add edi,ecx "&
  "xor ecx,-1 "&
  "inc ecx "&

  "mov ebx,[u1_2] "&
  "mov eax,[v1_2] "&
 
  "mov esi,[texture] "&

-- u = wwwwwwww ffffffff ffffffff
-- v = wwwwwwww ffffffff ffffffff
  "@@xloop: "&
   "mov ebp,eax "&      -- save eax 
   "shr eax,8 "&        -- 00000000 vvvvvvvv xxxxxxxx
   "mov edx,ebx "&      -- save ebx
   "and eax,65280 "&    -- 00000000 vvvvvvvv 00000000
   "shr ebx,16 "&       -- 00000000 00000000 uuuuuuuu
   "or eax,ebx "&       -- 00000000 vvvvvvvv uuuuuuuu
   "mov ebx,edx "&      -- restore ebx
   "movzx eax,byte ptr [esi + eax] "&
   "mov [edi + ecx],al "&
   "mov eax,ebp "&      -- restore eax 
   "add ebx,[d_u] "&
   "add eax,[d_v] "&
   "inc ecx "&
  "jnz @@xloop "&
  "@@xloop_done: "&

  "pop ecx "&
  "pop edi "&
  "@@yloop_next: "&
  "dec ecx "&
  "jz @@yloop_done "&
  "add edi,[screenW] "&
  "mov eax,[dxdy_1] "&
  "mov ebx,[dxdy_2] "&
  "add [x1],eax "&
  "add [x2],ebx "&
  "mov eax,[dudy_1] "&
  "mov ebx,[dudy_2] "&
  "add [u1],eax "&
  "add [u2],ebx "&
  "mov eax,[dvdy_1] "&
  "mov ebx,[dvdy_2] "&
  "add [v1],eax "&
  "add [v2],ebx "&
"jmp near @@yloop "&
"@@yloop_done: "&
"ret")
resolve_param("dxdy_1",poly_data+64)
resolve_param("dxdy_2",poly_data+68)
resolve_param("start_y",poly_data+112)
resolve_param("end_y",poly_data+120)
resolve_param("x1",poly_data+128)
resolve_param("x2",poly_data+132)
resolve_param("maxH",rMaxH)
resolve_param("maxW",rMaxW)
resolve_param("screenW",rScreenW)
resolve_param("texture",rTexture)
resolve_param("dudy_1",poly_data+232)
resolve_param("dudy_2",poly_data+236)
resolve_param("dvdy_1",poly_data+240)
resolve_param("dvdy_2",poly_data+244)
resolve_param("u1",poly_data+256)
resolve_param("v1",poly_data+260)
resolve_param("u2",poly_data+268)
resolve_param("v2",poly_data+272)
resolve_param("u1_2",poly_data+360)
resolve_param("u2_2",poly_data+364)
resolve_param("v1_2",poly_data+368)
resolve_param("v2_2",poly_data+372)
resolve_param("d_u",poly_data+384)
resolve_param("d_v",poly_data+388)


global constant drawtiledtexturesection8=get_asm(
"mov eax,[start_y] "&
"cmp eax,[maxH] "&
"jng @@y1_ok "&
  "ret "&
"@@y1_ok: "&

"mov ecx,[end_y] "&
"cmp ecx,0 "&
"jge @@y2_ok "&
  "ret "&
"@@y2_ok: "&

"cmp eax,0 "&
"jge @@y1_ok_2 "&
  "mov ebx,0 "&
  "sub ebx,eax "&
  "mov eax,[dxdy_1] "&
  "imul ebx "&
  "add [x1],eax "&
  "mov eax,[dxdy_2] "&
  "imul ebx "&
  "add [x2],eax "&
  "mov eax,[dudy_1] "&
  "imul ebx "&
  "add [u1],eax "&
  "mov eax,[dudy_2] "&
  "imul ebx "&
  "add [u2],eax "&
  "mov eax,[dvdy_1] "&
  "imul ebx "&
  "add [v1],eax "&
  "mov eax,[dvdy_2] "&
  "imul ebx "&
  "add [v2],eax "&
  "xor eax,eax "&
"@@y1_ok_2: "&

"cmp ecx,[maxH] "&
"jng @@y2_ok_2 "&
  "mov ecx,[maxH] "&
"@@y2_ok_2: "&

"sub ecx,eax "&
"inc ecx "&
"mul dword ptr [screenW] "&
"add edi,eax "&

"@@yloop: "&
  "mov ebp,[x1] "&
  "mov ebx,[x2] "&
  "sar ebp,9 "&
  "sar ebx,9 "&

  "mov eax,0 "&
  "mov edx,4 "&
  "cmp ebp,ebx "&
  "jng @@x1_ng_x2 "&
    "xchg ebp,ebx "&
    "xchg eax,edx "&
  "@@x1_ng_x2: "&
  "mov esi,[u1] "&
  "mov [u1_2+eax],esi "&
  "mov esi,[u2] "&
  "mov [u1_2+edx],esi "&
  "mov esi,[v1] "&
  "mov [v1_2+eax],esi "&
  "mov esi,[v2] "&
  "mov [v1_2+edx],esi "&

  "cmp ebp,[maxW] "&
  "jg near @@yloop_next "&
  "cmp ebx,0 "&
  "jl near @@yloop_next "&

  "push edi "&
  "push ecx "&

  "mov ecx,ebx "&
  "sub ecx,ebp "&
  "or ecx,ecx "&
  "setz dl "&
  "or cl,dl "&
  "mov eax,[u2_2] "&
  "sub eax,[u1_2] "&
  "cwd "&
  "idiv ecx "&
  "mov [d_u],eax "&
  "mov eax,[v2_2] "&
  "sub eax,[v1_2] "&
  "cwd "&
  "idiv ecx "&
  "mov [d_v],eax "&

  "cmp ebp,0 "&
  "jge @@x1_nl_zero "&
    "mov esi,0 "&
    "sub esi,ebp "&
    "mov eax,[d_u] "&
    "imul esi "&
    "add [u1_2],eax "&
    "mov eax,[d_v] "&
    "imul esi "&
    "add [v1_2],eax "&
    "mov ebp,0 "&
  "@@x1_nl_zero: "&

  "cmp ebx,[maxW] "&
  "jng @@x2_ng_maxW "&
    "mov ebx,[maxW] "&
  "@@x2_ng_maxW: "&

  "mov ecx,ebx "&
  "sub ecx,ebp "&
  "inc ecx "&
  "add edi,ebp "&

  "add edi,ecx "&
  "dec edi "&
  "xor ecx,-1 "&
  "inc ecx "&

  "mov eax,[d_u] "&
  "mov ebx,eax "&
  "mov ebp,eax "&
  "shl eax,8 shr ebx,1 "&
  "and eax,4160749568 and ebx,32767 and ebp,458752 "&
  "add ebx,ebp add eax,ebx or eax,133726208 "&
  "mov [d_u],eax "&

  "mov eax,[d_v] "&
  "mov ebx,eax "&
  "shl eax,3 shr ebx,1 "&
  "and eax,133693440 and ebx,32767 "&
  "add eax,ebx or eax,4161241088 "&
  "mov [d_v],eax "&

  "mov eax,[u1_2] "&
  "mov ebx,eax "&
  "mov ebp,eax "&
  "shl eax,8 shr ebx,1 "&
  "and eax,4160749568 and ebx,32767 and ebp,458752 "&
  "add ebx,ebp add eax,ebx "&
    
  "mov ebx,[v1_2] "&
  "mov ebp,ebx "&
  "shl ebx,3 shr ebp,1 "&
  "and ebx,133693440 and ebp,32767 "&
  "add ebx,ebp "&
  
  "mov esi,[texture] "&
  "lea ebp,[eax+ebx] "&

  "@@xloop: "&
   "add eax,[d_u] "&
   "shr ebp,16 "&
   "add ebx,[d_v] "&
   "and eax,4161241087 "&
   "and ebx,133726207 "&
   "inc ecx "&
   "mov dl,[esi+ebp] "&
   "lea ebp,[eax+ebx] "&
   "mov [edi+ecx],dl "&
  "jnz @@xloop "&
  "@@xloop_done: "&

  "pop ecx "&
  "pop edi "&
  "@@yloop_next: "&
  "dec ecx "&
  "jz @@yloop_done "&
  "add edi,[screenW] "&
  "mov eax,[dxdy_1] "&
  "mov ebx,[dxdy_2] "&
  "add [x1],eax "&
  "add [x2],ebx "&
  "mov eax,[dudy_1] "&
  "mov ebx,[dudy_2] "&
  "add [u1],eax "&
  "add [u2],ebx "&
  "mov eax,[dvdy_1] "&
  "mov ebx,[dvdy_2] "&
  "add [v1],eax "&
  "add [v2],ebx "&
"jmp near @@yloop "&
"@@yloop_done: "&
"ret")
resolve_param("dxdy_1",poly_data+64)
resolve_param("dxdy_2",poly_data+68)
resolve_param("start_y",poly_data+112)
resolve_param("end_y",poly_data+120)
resolve_param("x1",poly_data+128)
resolve_param("x2",poly_data+132)
resolve_param("maxH",rMaxH)
resolve_param("maxW",rMaxW)
resolve_param("screenW",rScreenW)
resolve_param("texture",rTexture)
resolve_param("dudy_1",poly_data+232)
resolve_param("dudy_2",poly_data+236)
resolve_param("dvdy_1",poly_data+240)
resolve_param("dvdy_2",poly_data+244)
resolve_param("u1",poly_data+256)
resolve_param("v1",poly_data+260)
resolve_param("u2",poly_data+268)
resolve_param("v2",poly_data+272)
resolve_param("u1_2",poly_data+360)
resolve_param("u2_2",poly_data+364)
resolve_param("v1_2",poly_data+368)
resolve_param("v2_2",poly_data+372)
resolve_param("d_u",poly_data+384)
resolve_param("d_v",poly_data+388)



global constant drawtexturesection1516=get_asm(
"mov eax,[start_y] "&
"cmp eax,[maxH] "&
"jng @@y1_ok "&
  "ret "&
"@@y1_ok: "&

"mov ecx,[end_y] "&
"cmp ecx,0 "&
"jge @@y2_ok "&
  "ret "&
"@@y2_ok: "&

"cmp eax,0 "&
"jge @@y1_ok_2 "&
  "mov ebx,0 "&
  "sub ebx,eax "&
  "mov eax,[dxdy_1] "&
  "imul ebx "&
  "add [x1],eax "&
  "mov eax,[dxdy_2] "&
  "imul ebx "&
  "add [x2],eax "&
  "mov eax,[dudy_1] "&
  "imul ebx "&
  "add [u1],eax "&
  "mov eax,[dudy_2] "&
  "imul ebx "&
  "add [u2],eax "&
  "mov eax,[dvdy_1] "&
  "imul ebx "&
  "add [v1],eax "&
  "mov eax,[dvdy_2] "&
  "imul ebx "&
  "add [v2],eax "&
  "xor eax,eax "&
"@@y1_ok_2: "&

"cmp ecx,[maxH] "&
"jng @@y2_ok_2 "&
  "mov ecx,[maxH] "&
"@@y2_ok_2: "&

"sub ecx,eax "&
"inc ecx "&
"mul dword ptr [screenW] "&
"lea edi,[edi+eax*2] "&

"@@yloop: "&
  "mov ebp,[x1] "&
  "mov ebx,[x2] "&
  "sar ebp,9 "&
  "sar ebx,9 "&

  "mov eax,0 "&
  "mov edx,4 "&
  "cmp ebp,ebx "&
  "jng @@x1_ng_x2 "&
    "xchg ebp,ebx "&
    "xchg eax,edx "&
  "@@x1_ng_x2: "&
  "mov esi,[u1] "&
  "mov [u1_2+eax],esi "&
  "mov esi,[u2] "&
  "mov [u1_2+edx],esi "&
  "mov esi,[v1] "&
  "mov [v1_2+eax],esi "&
  "mov esi,[v2] "&
  "mov [v1_2+edx],esi "&

  "cmp ebp,[maxW] "&
  "jg near @@yloop_next "&
  "cmp ebx,0 "&
  "jl near @@yloop_next "&

  "push edi "&
  "push ecx "&

  "mov ecx,ebx "&
  "sub ecx,ebp "&
  "or ecx,ecx "&
  "setz dl "&
  "or cl,dl "&
  "mov eax,[u2_2] "&
  "sub eax,[u1_2] "&
  "cwd "&
  "idiv ecx "&
  "mov [d_u],eax "&
  "mov eax,[v2_2] "&
  "sub eax,[v1_2] "&
  "cwd "&
  "idiv ecx "&
  "mov [d_v],eax "&

  "cmp ebp,0 "&
  "jge @@x1_nl_zero "&
    "mov esi,0 "&
    "sub esi,ebp "&
    "mov eax,[d_u] "&
    "imul esi "&
    "add [u1_2],eax "&
    "mov eax,[d_v] "&
    "imul esi "&
    "add [v1_2],eax "&
    "mov ebp,0 "&
  "@@x1_nl_zero: "&

  "cmp ebx,[maxW] "&
  "jng @@x2_ng_maxW "&
    "mov ebx,[maxW] "&
  "@@x2_ng_maxW: "&

  "mov ecx,ebx "&
  "sub ecx,ebp "&
  "inc ecx "&
  "lea edi,[edi+ebp*2] "&

  "lea edi,[edi+ecx*2] "&
  "xor ecx,-1 "&
  "inc ecx "&

  "mov ebx,[u1_2] "&
  "mov eax,[v1_2] "&
 
  "mov esi,[texture] "&

-- u = wwwwwwww ffffffff ffffffff
-- v = wwwwwwww ffffffff ffffffff
  "@@xloop: "&
   "mov ebp,eax "& 
   "shr eax,8 "&
   "mov edx,ebx "&
   "and eax,65280 "&
   "shr ebx,16 "&
   "or eax,ebx "&
   "mov ebx,edx "& 
   "movzx eax,word ptr [esi + eax*2] "&
   "mov [edi + ecx*2],ax "&
   "mov eax,ebp "& 
   "add ebx,[d_u] "&
   "add eax,[d_v] "&
   "inc ecx "&
  "jnz @@xloop "&
  "@@xloop_done: "&

  "pop ecx "&
  "pop edi "&
  "@@yloop_next: "&
  "dec ecx "&
  "jz @@yloop_done "&
  "add edi,[screenW] "&
  "add edi,[screenW] "&
  "mov eax,[dxdy_1] "&
  "mov ebx,[dxdy_2] "&
  "add [x1],eax "&
  "add [x2],ebx "&
  "mov eax,[dudy_1] "&
  "mov ebx,[dudy_2] "&
  "add [u1],eax "&
  "add [u2],ebx "&
  "mov eax,[dvdy_1] "&
  "mov ebx,[dvdy_2] "&
  "add [v1],eax "&
  "add [v2],ebx "&
"jmp near @@yloop "&
"@@yloop_done: "&
"ret")
resolve_param("dxdy_1",poly_data+64)
resolve_param("dxdy_2",poly_data+68)
resolve_param("start_y",poly_data+112)
resolve_param("end_y",poly_data+120)
resolve_param("x1",poly_data+128)
resolve_param("x2",poly_data+132)
resolve_param("maxH",rMaxH)
resolve_param("maxW",rMaxW)
resolve_param("screenW",rScreenW)
resolve_param("texture",rTexture)
resolve_param("dudy_1",poly_data+232)
resolve_param("dudy_2",poly_data+236)
resolve_param("dvdy_1",poly_data+240)
resolve_param("dvdy_2",poly_data+244)
resolve_param("u1",poly_data+256)
resolve_param("v1",poly_data+260)
resolve_param("u2",poly_data+268)
resolve_param("v2",poly_data+272)
resolve_param("u1_2",poly_data+360)
resolve_param("u2_2",poly_data+364)
resolve_param("v1_2",poly_data+368)
resolve_param("v2_2",poly_data+372)
resolve_param("d_u",poly_data+384)
resolve_param("d_v",poly_data+388)


global constant drawtiledtexturesection1516=get_asm(
"mov eax,[start_y] "&
"cmp eax,[maxH] "&
"jng @@y1_ok "&
  "ret "&
"@@y1_ok: "&

"mov ecx,[end_y] "&
"cmp ecx,0 "&
"jge @@y2_ok "&
  "ret "&
"@@y2_ok: "&

"cmp eax,0 "&
"jge @@y1_ok_2 "&
  "mov ebx,0 "&
  "sub ebx,eax "&
  "mov eax,[dxdy_1] "&
  "imul ebx "&
  "add [x1],eax "&
  "mov eax,[dxdy_2] "&
  "imul ebx "&
  "add [x2],eax "&
  "mov eax,[dudy_1] "&
  "imul ebx "&
  "add [u1],eax "&
  "mov eax,[dudy_2] "&
  "imul ebx "&
  "add [u2],eax "&
  "mov eax,[dvdy_1] "&
  "imul ebx "&
  "add [v1],eax "&
  "mov eax,[dvdy_2] "&
  "imul ebx "&
  "add [v2],eax "&
  "xor eax,eax "&
"@@y1_ok_2: "&

"cmp ecx,[maxH] "&
"jng @@y2_ok_2 "&
  "mov ecx,[maxH] "&
"@@y2_ok_2: "&

"sub ecx,eax "&
"inc ecx "&
"mul dword ptr [screenW] "&
"lea edi,[edi+eax*2] "&

"@@yloop: "&
  "mov ebp,[x1] "&
  "mov ebx,[x2] "&
  "sar ebp,9 "&
  "sar ebx,9 "&

  "mov eax,0 "&
  "mov edx,4 "&
  "cmp ebp,ebx "&
  "jng @@x1_ng_x2 "&
    "xchg ebp,ebx "&
    "xchg eax,edx "&
  "@@x1_ng_x2: "&
  "mov esi,[u1] "&
  "mov [u1_2+eax],esi "&
  "mov esi,[u2] "&
  "mov [u1_2+edx],esi "&
  "mov esi,[v1] "&
  "mov [v1_2+eax],esi "&
  "mov esi,[v2] "&
  "mov [v1_2+edx],esi "&

  "cmp ebp,[maxW] "&
  "jg near @@yloop_next "&
  "cmp ebx,0 "&
  "jl near @@yloop_next "&

  "push edi "&
  "push ecx "&

  "mov ecx,ebx "&
  "sub ecx,ebp "&
  "or ecx,ecx "&
  "setz dl "&
  "or cl,dl "&
  "mov eax,[u2_2] "&
  "sub eax,[u1_2] "&
  "cwd "&
  "idiv ecx "&
  "mov [d_u],eax "&
  "mov eax,[v2_2] "&
  "sub eax,[v1_2] "&
  "cwd "&
  "idiv ecx "&
  "mov [d_v],eax "&

  "cmp ebp,0 "&
  "jge @@x1_nl_zero "&
    "mov esi,0 "&
    "sub esi,ebp "&
    "mov eax,[d_u] "&
    "imul esi "&
    "add [u1_2],eax "&
    "mov eax,[d_v] "&
    "imul esi "&
    "add [v1_2],eax "&
    "mov ebp,0 "&
  "@@x1_nl_zero: "&

  "cmp ebx,[maxW] "&
  "jng @@x2_ng_maxW "&
    "mov ebx,[maxW] "&
  "@@x2_ng_maxW: "&

  "mov ecx,ebx "&
  "sub ecx,ebp "&
  "inc ecx "&
  "lea edi,[edi+ebp*2] "&

  "lea edi,[edi+ecx*2] "&
  "dec edi dec edi "&
  "xor ecx,-1 "&
  "inc ecx "&

  "mov eax,[d_u] "&
  "mov ebx,eax "&
  "mov ebp,eax "&
  "shl eax,8 shr ebx,1 "&
  "and eax,4160749568 "&
  "and ebx,32767 "&
  "and ebp,458752 "&
  "add ebx,ebp "&
  "add eax,ebx "&
  "or eax,133726208 "&
  "mov [d_u],eax "&

  "mov eax,[d_v] "&
  "mov ebx,eax "&
  "shl eax,3 "&
  "shr ebx,1 "&
  "and eax,133693440 "&
  "and ebx,32767 "&
  "add eax,ebx "&
  "or eax,4161241088 "&
  "mov [d_v],eax "&

  "mov eax,[u1_2] "&
  "mov ebx,eax "&
  "mov ebp,eax "&
  "shl eax,8 "&
  "shr ebx,1 "&
  "and eax,4160749568 "&
  "and ebx,32767 "&
  "and ebp,458752 "&
  "add ebx,ebp "&
  "add eax,ebx "&
    
  "mov ebx,[v1_2] "&
  "mov ebp,ebx "&
  "shl ebx,3 shr ebp,1 "&
  "and ebx,133693440 "&
  "and ebp,32767 "&
  "add ebx,ebp "&
  
  "mov esi,[texture] "&
  "lea ebp,[eax+ebx] "&

  "@@xloop: "&
   "add eax,[d_u] "&
   "shr ebp,16 "&
   "add ebx,[d_v] "&
   "and eax,4161241087 "&
   "and ebx,133726207 "&
   "inc ecx "&
   "mov dx,[esi+ebp*2] "&
   "lea ebp,[eax+ebx] "&
   "mov [edi+ecx*2],dx "&
  "jnz @@xloop "&
  "@@xloop_done: "&

  "pop ecx "&
  "pop edi "&
  "@@yloop_next: "&
  "dec ecx "&
  "jz @@yloop_done "&
  "add edi,[screenW] "&
  "add edi,[screenW] "&
  "mov eax,[dxdy_1] "&
  "mov ebx,[dxdy_2] "&
  "add [x1],eax "&
  "add [x2],ebx "&
  "mov eax,[dudy_1] "&
  "mov ebx,[dudy_2] "&
  "add [u1],eax "&
  "add [u2],ebx "&
  "mov eax,[dvdy_1] "&
  "mov ebx,[dvdy_2] "&
  "add [v1],eax "&
  "add [v2],ebx "&
"jmp near @@yloop "&
"@@yloop_done: "&
"ret")
resolve_param("dxdy_1",poly_data+64)
resolve_param("dxdy_2",poly_data+68)
resolve_param("start_y",poly_data+112)
resolve_param("end_y",poly_data+120)
resolve_param("x1",poly_data+128)
resolve_param("x2",poly_data+132)
resolve_param("maxH",rMaxH)
resolve_param("maxW",rMaxW)
resolve_param("screenW",rScreenW)
resolve_param("texture",rTexture)
resolve_param("dudy_1",poly_data+232)
resolve_param("dudy_2",poly_data+236)
resolve_param("dvdy_1",poly_data+240)
resolve_param("dvdy_2",poly_data+244)
resolve_param("u1",poly_data+256)
resolve_param("v1",poly_data+260)
resolve_param("u2",poly_data+268)
resolve_param("v2",poly_data+272)
resolve_param("u1_2",poly_data+360)
resolve_param("u2_2",poly_data+364)
resolve_param("v1_2",poly_data+368)
resolve_param("v2_2",poly_data+372)
resolve_param("d_u",poly_data+384)
resolve_param("d_v",poly_data+388)




global constant drawtexturesection24=get_asm(
"mov eax,[start_y] "&
"cmp eax,[maxH] "&
"jng @@y1_ok "&
  "ret "&
"@@y1_ok: "&

"mov ecx,[end_y] "&
"cmp ecx,0 "&
"jge @@y2_ok "&
  "ret "&
"@@y2_ok: "&

"cmp eax,0 "&
"jge @@y1_ok_2 "&
  "mov ebx,0 "&
  "sub ebx,eax "&
  "mov eax,[dxdy_1] "&
  "imul ebx "&
  "add [x1],eax "&
  "mov eax,[dxdy_2] "&
  "imul ebx "&
  "add [x2],eax "&
  "mov eax,[dudy_1] "&
  "imul ebx "&
  "add [u1],eax "&
  "mov eax,[dudy_2] "&
  "imul ebx "&
  "add [u2],eax "&
  "mov eax,[dvdy_1] "&
  "imul ebx "&
  "add [v1],eax "&
  "mov eax,[dvdy_2] "&
  "imul ebx "&
  "add [v2],eax "&
  "xor eax,eax "&
"@@y1_ok_2: "&

"cmp ecx,[maxH] "&
"jng @@y2_ok_2 "&
  "mov ecx,[maxH] "&
"@@y2_ok_2: "&

"sub ecx,eax "&
"inc ecx "&
"mul dword ptr [screenW] "&
"lea edi,[edi+eax*2] "&
"add edi,eax "&

"@@yloop: "&
  "mov ebp,[x1] "&
  "mov ebx,[x2] "&
  "sar ebp,9 "&
  "sar ebx,9 "&

  "mov eax,0 "&
  "mov edx,4 "&
  "cmp ebp,ebx "&
  "jng @@x1_ng_x2 "&
    "xchg ebp,ebx "&
    "xchg eax,edx "&
  "@@x1_ng_x2: "&
  "mov esi,[u1] "&
  "mov [u1_2+eax],esi "&
  "mov esi,[u2] "&
  "mov [u1_2+edx],esi "&
  "mov esi,[v1] "&
  "mov [v1_2+eax],esi "&
  "mov esi,[v2] "&
  "mov [v1_2+edx],esi "&

  "cmp ebp,[maxW] "&
  "jg near @@yloop_next "&
  "cmp ebx,0 "&
  "jl near @@yloop_next "&

  "push edi "&
  "push ecx "&

  "mov ecx,ebx "&
  "sub ecx,ebp "&
  "or ecx,ecx "&
  "setz dl "&
  "or cl,dl "&
  "mov eax,[u2_2] "&
  "sub eax,[u1_2] "&
  "cwd "&
  "idiv ecx "&
  "mov [d_u],eax "&
  "mov eax,[v2_2] "&
  "sub eax,[v1_2] "&
  "cwd "&
  "idiv ecx "&
  "mov [d_v],eax "&

  "cmp ebp,0 "&
  "jge @@x1_nl_zero "&
    "mov esi,0 "&
    "sub esi,ebp "&
    "mov eax,[d_u] "&
    "imul esi "&
    "add [u1_2],eax "&
    "mov eax,[d_v] "&
    "imul esi "&
    "add [v1_2],eax "&
    "mov ebp,0 "&
  "@@x1_nl_zero: "&

  "cmp ebx,[maxW] "&
  "jng @@x2_ng_maxW "&
    "mov ebx,[maxW] "&
  "@@x2_ng_maxW: "&

  "mov ecx,ebx "&
  "sub ecx,ebp "&
  "inc ecx "&
  "lea edi,[edi+ebp*2] "&
  "add edi,ebp "&

  "lea edi,[edi+ecx*2] "&
  "add edi,ecx "&
  "xor ecx,-1 "&
  "inc ecx "&

  "mov ebx,[u1_2] "&
  "mov eax,[v1_2] "&
 
  "mov esi,[texture] "&

-- u = wwwwwwww ffffffff ffffffff
-- v = wwwwwwww ffffffff ffffffff
  "@@xloop: "&
   "push ecx "&
   "mov ebp,eax "& 
   "shr eax,8 "&
   "mov edx,ebx "&
   "and eax,65280 "&
   "shr ebx,16 "&
   "or eax,ebx "&
   "mov ebx,edx "& 
   "lea edx,[eax*2 + eax] "&
   "lea ecx,[ecx*2 + ecx] "&
   "add edx,esi "&
   "add ecx,edi "&
   "mov ax,[edx] "&
   "mov [ecx],ax "&
   "movzx eax,byte ptr [edx+2] "&
   "mov [ecx+2],al "&
   "pop ecx "&
   "mov eax,ebp "& 
   "add ebx,[d_u] "&
   "add eax,[d_v] "&
   "inc ecx "&
  "jnz @@xloop "&
  "@@xloop_done: "&

  "pop ecx "&
  "pop edi "&
  "@@yloop_next: "&
  "dec ecx "&
  "jz @@yloop_done "&
  "add edi,[screenW] "&
  "add edi,[screenW] "&
  "add edi,[screenW] "&
  "mov eax,[dxdy_1] "&
  "mov ebx,[dxdy_2] "&
  "add [x1],eax "&
  "add [x2],ebx "&
  "mov eax,[dudy_1] "&
  "mov ebx,[dudy_2] "&
  "add [u1],eax "&
  "add [u2],ebx "&
  "mov eax,[dvdy_1] "&
  "mov ebx,[dvdy_2] "&
  "add [v1],eax "&
  "add [v2],ebx "&
"jmp near @@yloop "&
"@@yloop_done: "&
"ret")
resolve_param("dxdy_1",poly_data+64)
resolve_param("dxdy_2",poly_data+68)
resolve_param("start_y",poly_data+112)
resolve_param("end_y",poly_data+120)
resolve_param("x1",poly_data+128)
resolve_param("x2",poly_data+132)
resolve_param("maxH",rMaxH)
resolve_param("maxW",rMaxW)
resolve_param("screenW",rScreenW)
resolve_param("texture",rTexture)
resolve_param("dudy_1",poly_data+232)
resolve_param("dudy_2",poly_data+236)
resolve_param("dvdy_1",poly_data+240)
resolve_param("dvdy_2",poly_data+244)
resolve_param("u1",poly_data+256)
resolve_param("v1",poly_data+260)
resolve_param("u2",poly_data+268)
resolve_param("v2",poly_data+272)
resolve_param("u1_2",poly_data+360)
resolve_param("u2_2",poly_data+364)
resolve_param("v1_2",poly_data+368)
resolve_param("v2_2",poly_data+372)
resolve_param("d_u",poly_data+384)
resolve_param("d_v",poly_data+388)



--!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
--!!   !!!!! !!!!!! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! !!!!!!!!!! !! !!!!!!!!!!!
--! !!! !!!  !!!!!! !!!!!!! !!! !!!!!!!!!!!!!!!!!!!!!!! !!!!!!!!!! !! !!!!!!!!!!!
--!!!!! !! ! !!!!!! !!!!!!!!!!   !!!!!    ! !!! !!   !! !! !!    ! !! !!!!!!!!!!!
--!!!! !! !! !!!!!! !   !!!  !! !!!!! !!!!! !!! ! !!!!! ! !! !!!!! !! !!!!!!!!!!!
--!!! !!!     !   !  !!! !! !!! !!!!!!   !! !!! ! !!!!!  !!!!   !! !! !!!!!!!!!!!
--!! !!!!!!! !!!!!! !!!! !! !!! ! !!!!!!! ! !!! ! !!! ! ! !!!!!! !!!!!!!!!!!!!!!!
--!     !!!! !!!!!!    !!!   !!! !!!!    !!!   !!!   !! !! !    !! !! !! !! !! !!
--!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

constant tri=get_asm(
"pusha "&
"cld "&
"mov esi,[vertex_ptr_1] "&
"mov edi,[vertex_ptr_2] "&
"mov ebx,[vertex_ptr_3] "&

"mov eax,[esi + 4] "&		--eax = y1
"cmp eax,[edi + 4] "&		--cmp y1,y2
"jng tri_@y1_ng_y2 "&
  "xchg esi,edi "&
"tri_@y1_ng_y2: "&

"mov eax,[esi + 4] "&		--eax = y1
"cmp eax,[ebx + 4] "&		--cmp y1,y3
"jng tri_@y2_ng_y3 "&
  "xchg esi,ebx "&
"tri_@y2_ng_y3: "&

"mov eax,[edi + 4] "&		--eax = y2
"cmp eax,[ebx + 4] "&		--cmp y2,y3
"jng tri_@y1_ng_y3 "&
  "xchg edi,ebx "&
"tri_@y1_ng_y3: "&

 "mov [vertex_ptr_1],esi "&
 "mov [vertex_ptr_2],edi "&
 "mov [vertex_ptr_3],ebx "&
 "mov eax,[edi] "&
 "sub eax,[esi] "&
 "mov [delta_x_1],eax "&

 "mov eax,[ebx] "&
 "sub eax,[edi] "&
 "mov [delta_x_2],eax "&

 "mov eax,[ebx] "&		
 "sub eax,[esi] "&		
 "mov [delta_x_3],eax "&

 "mov eax,[edi + 4] "&
 "sub eax,[esi + 4] "&
 "mov [delta_y_1],eax "&

 "mov eax,[ebx + 4] "&
 "sub eax,[edi + 4] "&
 "mov [delta_y_2],eax "&

 "mov eax,[ebx + 4] "&		
 "sub eax,[esi + 4] "&		
 "mov [delta_y_3],eax "&

 "xor ebp,ebp "&
 "mov [d_1],ebp "&
 "mov [d_2],ebp "&
 "mov [d_3],ebp "&
  "mov eax,[delta_x_3] "&
  "sal eax,9 "&
  "mov ebx,[delta_y_3] "&
  "xor ecx,ecx "&
  "or ebx,ebx "&
  "setz cl "&
  "or ebx,ecx "&
  "cwd "&
  "idiv ebx "&
  "mov [d_3],eax "&

  "mov eax,[delta_x_2] "&
  "sal eax,9 "&
  "mov ebx,[delta_y_2] "&
  "mov ecx,0 "&
  "or ebx,ebx "&
  "setz cl "&
  "or ebx,ecx "&
  "cwd "&
  "idiv ebx "&
  "mov [d_2],eax "&

 "tri_@delta_y_2_zero: "&
  "mov eax,[delta_x_1] "&
  "sal eax,9 "&
  "mov ebx,[delta_y_1] "&
  "mov ecx,0 "&
  "or ebx,ebx "&
  "setz cl "&
  "or ebx,ecx "&
  "cwd "&
  "idiv ebx "&
  "mov [d_1],eax "&
 "tri_@delta_y_1_zero: "&
"tri_@enough_height: "&
"mov eax,[vertex_ptr_1] "&
"mov ebx,[vertex_ptr_2] "&
"mov edx,[eax + 4] "&
"mov eax,[ebx + 4] "&
"mov [start_y],edx "&
"mov [end_y],eax "&
"mov ebx,[vertex_ptr_1] "&
"mov eax,[ebx] "&
"sal eax,9 "&
"mov [x1],eax "&
"mov [x2],eax "&
"mov eax,[d_1] "&
"mov ebx,[d_3] "&
"mov [dxdy_1],eax "&
"mov [dxdy_2],ebx "&
"mov edi,[tri_dest] "&
"mov ebx,[draw_section] "&
"call near ebx "&			--draw upper section

"mov ebx,[vertex_ptr_2] "&
"mov ebx,[ebx] "&
"sal ebx,9 "&
"mov [x1],ebx "&
"mov eax,[vertex_ptr_2] "&
"mov ebx,[vertex_ptr_3] "&
"mov edx,[eax + 4] "&
"mov eax,[ebx + 4] "&
"mov [start_y],edx "&
"mov [end_y],eax "&
"mov eax,[d_2] "&
"mov ebx,[d_3] "&
"mov [dxdy_1],eax "&
"mov [dxdy_2],ebx "&
"mov edi,[tri_dest] "&
"mov ebx,[draw_section] "&
"call near ebx "&			--draw lower section
"popa "&
"ret")
resolve_param("vertex_ptr_1",poly_data)
resolve_param("vertex_ptr_2",poly_data+4)
resolve_param("vertex_ptr_3",poly_data+8)
resolve_param("delta_x_1",poly_data+16)
resolve_param("delta_x_2",poly_data+20)
resolve_param("delta_x_3",poly_data+24)
resolve_param("delta_y_1",poly_data+32)
resolve_param("delta_y_2",poly_data+36)
resolve_param("delta_y_3",poly_data+40)
resolve_param("d_1",poly_data+48)
resolve_param("d_2",poly_data+52)
resolve_param("d_3",poly_data+56)
resolve_param("dxdy_1",poly_data+64)
resolve_param("dxdy_2",poly_data+68)
resolve_param("tri_dest",poly_data+72)
resolve_param("draw_section",rFlatCode)
resolve_param("start_y",poly_data+112)
resolve_param("end_y",poly_data+120)
resolve_param("x1",poly_data+128)
resolve_param("x2",poly_data+132)



constant gtri=get_asm(
"pusha "&
"cld "&
"mov esi,[vertex_ptr_1] "&
"mov edi,[vertex_ptr_2] "&
"mov ebx,[vertex_ptr_3] "&

"mov eax,[esi + 4] "&		--eax = y1
"cmp eax,[edi + 4] "&		--cmp y1,y2
"jng @@y1_ng_y2 "&
  "xchg esi,edi "&
"@@y1_ng_y2: "&

"mov eax,[esi + 4] "&		--eax = y1
"cmp eax,[ebx + 4] "&		--cmp y1,y3
"jng @@y2_ng_y3 "&
  "xchg esi,ebx "&
"@@y2_ng_y3: "&

"mov eax,[edi + 4] "&		--eax = y2
"cmp eax,[ebx + 4] "&		--cmp y2,y3
"jng @@y1_ng_y3 "&
  "xchg edi,ebx "&
"@@y1_ng_y3: "&

 "mov [vertex_ptr_1],esi "&
 "mov [vertex_ptr_2],edi "&
 "mov [vertex_ptr_3],ebx "&
 "mov eax,[edi] "&
 "sub eax,[esi] "&
 "mov [delta_x_1],eax "&

 "mov eax,[ebx] "&
 "sub eax,[edi] "&
 "mov [delta_x_2],eax "&

 "mov eax,[ebx] "&		
 "sub eax,[esi] "&		
 "mov [delta_x_3],eax "&

 "mov eax,[edi + 4] "&
 "sub eax,[esi + 4] "&
 "mov [delta_y_1],eax "&

 "mov eax,[ebx + 4] "&
 "sub eax,[edi + 4] "&
 "mov [delta_y_2],eax "&

 "mov eax,[ebx + 4] "&		
 "sub eax,[esi + 4] "&		
 "mov [delta_y_3],eax "&

 "mov eax,[edi+8] "&
 "sub eax,[esi+8] "&
 "mov [delta_c_1],eax "&

 "mov eax,[ebx+8] "&
 "sub eax,[edi+8] "&
 "mov [delta_c_2],eax "&

 "mov eax,[ebx+8] "&		
 "sub eax,[esi+8] "&		
 "mov [delta_c_3],eax "&

  "mov eax,[delta_x_3] "&
  "sal eax,8 "&
  "mov ebx,[delta_y_3] "&
  "or ebx,ebx "&
  "setz dl "&
  "or bl,dl "&
  "cwd "&
  "idiv ebx "&
  "mov [d_3],eax "&
  "mov eax,[delta_c_3] "&
  "sal eax,8 "&
  "cwd "&
  "idiv ebx "&
  "mov [dc_3],eax "&

  "mov eax,[delta_x_2] "&
  "sal eax,8 "&
  "mov ebx,[delta_y_2] "&
  "or ebx,ebx "&
  "setz dl "&
  "or bl,dl "&
  "cwd "&
  "idiv ebx "&
  "mov [d_2],eax "&
  "mov eax,[delta_c_2] "&
  "sal eax,8 "&
  "cwd "&
  "idiv ebx "&
  "mov [dc_2],eax "&

  "mov eax,[delta_x_1] "&
  "sal eax,8 "&
  "mov ebx,[delta_y_1] "&
  "or ebx,ebx "&
  "setz dl "&
  "or bl,dl "&
  "cwd "&
  "idiv ebx "&
  "mov [d_1],eax "&
  "mov eax,[delta_c_1] "&
  "sal eax,8 "&
  "cwd "&
  "idiv ebx "&
  "mov [dc_1],eax "&

"mov eax,[vertex_ptr_1] "&
"mov ebx,[vertex_ptr_2] "&
"mov edx,[eax + 4] "&
"mov eax,[ebx + 4] "&
"mov [start_y],edx "&
"mov [end_y],eax "&
"mov esi,[vertex_ptr_1] "&
"mov eax,[esi] "&
"sal eax,8 "&
"mov [x1],eax "&
"mov [x2],eax "&

"mov eax,[esi+8] "&
"shl eax,8 "&
"mov [c1],eax "&
"mov [c2],eax "&
"mov eax,[d_1] "&
"mov ebx,[d_3] "&
"mov ecx,[dc_1] "&
"mov edx,[dc_3] "&
"mov [dxdy_1],eax "&
"mov [dxdy_2],ebx "&
"mov [dcdy_1],ecx "&
"mov [dcdy_2],edx "&
"mov edi,[tri_dest] "&
"mov ebx,draw_section "&
"call near ebx "&			--draw upper section

"mov ebx,[vertex_ptr_2] "&
"mov eax,[ebx] "&
"sal eax,8 "&
"mov [x1],eax "&
"mov eax,[ebx+8] "&
"shl eax,8 "&
"mov [c1],eax "&
"mov eax,[vertex_ptr_2] "&
"mov ebx,[vertex_ptr_3] "&
"mov edx,[eax + 4] "&
"mov eax,[ebx + 4] "&
"mov [start_y],edx "&
"mov [end_y],eax "&
"mov eax,[d_2] "&
"mov ebx,[d_3] "&
"mov ecx,[dc_2] "&
"mov edx,[dc_3] "&
"mov [dxdy_1],eax "&
"mov [dxdy_2],ebx "&
"mov [dcdy_1],ecx "&
"mov [dcdy_2],edx "&
"mov edi,[tri_dest] "&
"mov ebx,draw_section "&
"call near ebx "&			--draw lower section
"popa "&
"ret")
resolve_param("vertex_ptr_1",poly_data)
resolve_param("vertex_ptr_2",poly_data+4)
resolve_param("vertex_ptr_3",poly_data+8)
resolve_param("delta_x_1",poly_data+16)
resolve_param("delta_x_2",poly_data+20)
resolve_param("delta_x_3",poly_data+24)
resolve_param("delta_y_1",poly_data+32)
resolve_param("delta_y_2",poly_data+36)
resolve_param("delta_y_3",poly_data+40)
resolve_param("delta_c_1",poly_data+160)
resolve_param("delta_c_2",poly_data+164)
resolve_param("delta_c_3",poly_data+168)
resolve_param("d_1",poly_data+48)
resolve_param("d_2",poly_data+52)
resolve_param("d_3",poly_data+56)
resolve_param("dc_1",poly_data+172)
resolve_param("dc_2",poly_data+176)
resolve_param("dc_3",poly_data+180)
resolve_param("dxdy_1",poly_data+64)
resolve_param("dxdy_2",poly_data+68)
resolve_param("dcdy_1",poly_data+184)
resolve_param("dcdy_2",poly_data+188)
resolve_param("tri_dest",poly_data+72)
resolve_param("draw_section",drawgouraudsection8)
resolve_param("start_y",poly_data+112)
resolve_param("end_y",poly_data+120)
resolve_param("x1",poly_data+128)
resolve_param("x2",poly_data+132)
resolve_param("c1",poly_data+192)
resolve_param("c2",poly_data+196)





-- color interpolation:
--  R : 0wwwwwff ffffffff
--  G : 000wwwww ffffffff
--  B : 000wwwww ffffffff
--
-- (w=whole, f=frac)

constant gtri15=get_asm(
"pusha "&
"cld "&
"mov esi,[vertex_ptr_1] "&
"mov edi,[vertex_ptr_2] "&
"mov ebx,[vertex_ptr_3] "&

"mov eax,[esi + 4] "&		--eax = y1
"cmp eax,[edi + 4] "&		--cmp y1,y2
"jng @@y1_ng_y2 "&
  "xchg esi,edi "&
"@@y1_ng_y2: "&

"mov eax,[esi + 4] "&		--eax = y1
"cmp eax,[ebx + 4] "&		--cmp y1,y3
"jng @@y2_ng_y3 "&
  "xchg esi,ebx "&
"@@y2_ng_y3: "&

"mov eax,[edi + 4] "&		--eax = y2
"cmp eax,[ebx + 4] "&		--cmp y2,y3
"jng @@y1_ng_y3 "&
  "xchg edi,ebx "&
"@@y1_ng_y3: "&

 "mov [vertex_ptr_1],esi "&
 "mov [vertex_ptr_2],edi "&
 "mov [vertex_ptr_3],ebx "&
 "mov eax,[edi] "&
 "sub eax,[esi] "&
 "mov [delta_x_1],eax "&

 "mov eax,[ebx] "&
 "sub eax,[edi] "&
 "mov [delta_x_2],eax "&

 "mov eax,[ebx] "&		
 "sub eax,[esi] "&		
 "mov [delta_x_3],eax "&

 "mov eax,[edi + 4] "&
 "sub eax,[esi + 4] "&
 "mov [delta_y_1],eax "&

 "mov eax,[ebx + 4] "&
 "sub eax,[edi + 4] "&
 "mov [delta_y_2],eax "&

 "mov eax,[ebx + 4] "&		
 "sub eax,[esi + 4] "&		
 "mov [delta_y_3],eax "&

 "mov ax,[edi+8] "&
 "mov dx,[esi+8] "&
 "and eax,31 "&
 "and edx,31 "&
 "sub eax,edx "& 
 "mov [delta_b_1],eax "&
 "mov ax,[ebx+8] "&
 "and eax,31 "&
 "sub eax,edx "& 
 "mov [delta_b_3],eax "&
 "mov ax,[ebx+8] "&
 "mov dx,[edi+8] "&
 "and eax,31 "&
 "and edx,31 "&
 "sub eax,edx "& 
 "mov [delta_b_2],eax "&

 "mov ax,[edi+8] "&
 "mov dx,[esi+8] "&
 "and eax,992 "&
 "and edx,992 "&
 "shr eax,5 "&
 "shr edx,5 "&
 "sub eax,edx "& 
 "mov [delta_g_1],eax "&
 "mov ax,[ebx+8] "&
 "and eax,992 "&
 "shr eax,5 "&
 "sub eax,edx "& 
 "mov [delta_g_3],eax "&
 "mov ax,[ebx+8] "&
 "mov dx,[edi+8] "&
 "and eax,992 "&
 "and edx,992 "&
 "shr eax,5 "&
 "shr edx,5 "&
 "sub eax,edx "& 
 "mov [delta_g_2],eax "&

 "mov ax,[edi+8] "&
 "mov dx,[esi+8] "&
 "and eax,31744 "&
 "and edx,31744 "&
 "shr eax,10 "&
 "shr edx,10 "&
 "sub eax,edx "& 
 "mov [delta_r_1],eax "&
 "mov ax,[ebx+8] "&
 "and eax,31744 "&
 "shr eax,10 "&
 "sub eax,edx "& 
 "mov [delta_r_3],eax "&
 "mov ax,[ebx+8] "&
 "mov dx,[edi+8] "&
 "and eax,31744 "&
 "and edx,31744 "&
 "shr eax,10 "&
 "shr edx,10 "&
 "sub eax,edx "& 
 "mov [delta_r_2],eax "&

  "mov eax,[delta_x_3] "&
  "sal eax,9 "&
  "mov ebx,[delta_y_3] "&
  "or ebx,ebx "&
  "setz dl "&
  "or bl,dl "&
  "cwd "&
  "idiv ebx "&
  "mov [d_3],eax "&
  "mov eax,[delta_r_3] "&
  "sal eax,10 "&
  "cwd "&
  "idiv ebx "&
  "mov [dr_3],eax "&
  "mov eax,[delta_g_3] "&
  "sal eax,8 "&
  "cwd "&
  "idiv ebx "&
  "mov [dg_3],eax "&
  "mov eax,[delta_b_3] "&
  "sal eax,8 "&
  "cwd "&
  "idiv ebx "&
  "mov [db_3],eax "&

  "mov eax,[delta_x_2] "&
  "sal eax,9 "&
  "mov ebx,[delta_y_2] "&
  "or ebx,ebx "&
  "setz dl "&
  "or bl,dl "&
  "cwd "&
  "idiv ebx "&
  "mov [d_2],eax "&
  "mov eax,[delta_r_2] "&
  "sal eax,10 "&
  "cwd "&
  "idiv ebx "&
  "mov [dr_2],eax "&
  "mov eax,[delta_g_2] "&
  "sal eax,8 "&
  "cwd "&
  "idiv ebx "&
  "mov [dg_2],eax "&
  "mov eax,[delta_b_2] "&
  "sal eax,8 "&
  "cwd "&
  "idiv ebx "&
  "mov [db_2],eax "&

  "mov eax,[delta_x_1] "&
  "sal eax,9 "&
  "mov ebx,[delta_y_1] "&
  "or ebx,ebx "&
  "setz dl "&
  "or bl,dl "&
  "cwd "&
  "idiv ebx "&
  "mov [d_1],eax "&
  "mov eax,[delta_r_1] "&
  "sal eax,10 "&
  "cwd "&
  "idiv ebx "&
  "mov [dr_1],eax "&
  "mov eax,[delta_g_1] "&
  "sal eax,8 "&
  "cwd "&
  "idiv ebx "&
  "mov [dg_1],eax "&
  "mov eax,[delta_b_1] "&
  "sal eax,8 "&
  "cwd "&
  "idiv ebx "&
  "mov [db_1],eax "&

"mov eax,[vertex_ptr_1] "&
"mov ebx,[vertex_ptr_2] "&
"mov edx,[eax + 4] "&
"mov eax,[ebx + 4] "&
"mov [start_y],edx "&
"mov [end_y],eax "&
"mov esi,[vertex_ptr_1] "&
"mov eax,[esi] "&
"sal eax,9 "&
"mov [x1],eax "&
"mov [x2],eax "&

"mov ax,[esi+8] "&
"mov ebx,eax "&
"mov ecx,eax "&
"and eax,31 "&
"shl eax,8 "&
"and ebx,992 "&
"shl ebx,3 "&
"and ecx,31744 "&

"mov [b1],eax "&
"mov [g1],ebx "&
"mov [r1],ecx "&
"mov [b2],eax "&
"mov [g2],ebx "&
"mov [r2],ecx "&

"mov eax,[d_1] "&
"mov ebx,[d_3] "&
"mov ecx,[dr_1] "&
"mov edx,[dr_3] "&
"mov [dxdy_1],eax "&
"mov [dxdy_2],ebx "&
"mov [drdy_1],ecx "&
"mov [drdy_2],edx "&
"mov eax,[dg_1] "&
"mov ebx,[dg_3] "&
"mov ecx,[db_1] "&
"mov edx,[db_3] "&
"mov [dgdy_1],eax "&
"mov [dgdy_2],ebx "&
"mov [dbdy_1],ecx "&
"mov [dbdy_2],edx "&
"mov edi,[tri_dest] "&
"mov ebx,draw_section "&
"call near ebx "&			--draw upper section

"mov ebx,[vertex_ptr_2] "&
"mov eax,[ebx] "&
"sal eax,9 "&
"mov [x1],eax "&
"mov ax,[ebx+8] "&
"mov ebx,eax "&
"mov ecx,eax "&
"and eax,31 "&
"shl eax,8 "&
"and ebx,992 "&
"shl ebx,3 "&
"and ecx,31744 "&
"mov [b1],eax "&
"mov [g1],ebx "&
"mov [r1],ecx "&
"mov eax,[vertex_ptr_2] "&
"mov ebx,[vertex_ptr_3] "&
"mov edx,[eax + 4] "&
"mov eax,[ebx + 4] "&
"mov [start_y],edx "&
"mov [end_y],eax "&
"mov eax,[d_2] "&
"mov ebx,[d_3] "&
"mov ecx,[dr_2] "&
"mov edx,[dr_3] "&
"mov [dxdy_1],eax "&
"mov [dxdy_2],ebx "&
"mov [drdy_1],ecx "&
"mov [drdy_2],edx "&
"mov eax,[dg_2] "&
"mov ebx,[dg_3] "&
"mov ecx,[db_2] "&
"mov edx,[db_3] "&
"mov [dgdy_1],eax "&
"mov [dgdy_2],ebx "&
"mov [dbdy_1],ecx "&
"mov [dbdy_2],edx "&
"mov edi,[tri_dest] "&
"mov ebx,draw_section "&
"call near ebx "&			--draw lower section
"popa "&
"ret")
resolve_param("vertex_ptr_1",poly_data)
resolve_param("vertex_ptr_2",poly_data+4)
resolve_param("vertex_ptr_3",poly_data+8)
resolve_param("delta_x_1",poly_data+16)
resolve_param("delta_x_2",poly_data+20)
resolve_param("delta_x_3",poly_data+24)
resolve_param("delta_y_1",poly_data+32)
resolve_param("delta_y_2",poly_data+36)
resolve_param("delta_y_3",poly_data+40)
resolve_param("delta_r_1",poly_data+160)
resolve_param("delta_r_2",poly_data+164)
resolve_param("delta_r_3",poly_data+168)
resolve_param("delta_g_1",poly_data+172)
resolve_param("delta_g_2",poly_data+176)
resolve_param("delta_g_3",poly_data+180)
resolve_param("delta_b_1",poly_data+184)
resolve_param("delta_b_2",poly_data+188)
resolve_param("delta_b_3",poly_data+192)
resolve_param("d_1",poly_data+48)
resolve_param("d_2",poly_data+52)
resolve_param("d_3",poly_data+56)
resolve_param("dr_1",poly_data+196)
resolve_param("dr_2",poly_data+200)
resolve_param("dr_3",poly_data+204)
resolve_param("dg_1",poly_data+208)
resolve_param("dg_2",poly_data+212)
resolve_param("dg_3",poly_data+216)
resolve_param("db_1",poly_data+220)
resolve_param("db_2",poly_data+224)
resolve_param("db_3",poly_data+228)
resolve_param("dxdy_1",poly_data+64)
resolve_param("dxdy_2",poly_data+68)
resolve_param("drdy_1",poly_data+232)
resolve_param("drdy_2",poly_data+236)
resolve_param("dgdy_1",poly_data+240)
resolve_param("dgdy_2",poly_data+244)
resolve_param("dbdy_1",poly_data+248)
resolve_param("dbdy_2",poly_data+252)
resolve_param("tri_dest",poly_data+72)
resolve_param("draw_section",drawgouraudsection15)
resolve_param("start_y",poly_data+112)
resolve_param("end_y",poly_data+120)
resolve_param("x1",poly_data+128)
resolve_param("x2",poly_data+132)
resolve_param("r1",poly_data+256)
resolve_param("g1",poly_data+260)
resolve_param("b1",poly_data+264)
resolve_param("r2",poly_data+268)
resolve_param("g2",poly_data+272)
resolve_param("b2",poly_data+276)



-- color interpolation:
--  R : wwwwwfff ffffffff
--  G : 00wwwwww ffffffff
--  B : 000wwwww ffffffff
--
-- (w=whole, f=frac)

constant gtri16=get_asm(
"pusha "&
"cld "&
"mov esi,[vertex_ptr_1] "&
"mov edi,[vertex_ptr_2] "&
"mov ebx,[vertex_ptr_3] "&

"mov eax,[esi + 4] "&		--eax = y1
"cmp eax,[edi + 4] "&		--cmp y1,y2
"jng @@y1_ng_y2 "&
  "xchg esi,edi "&
"@@y1_ng_y2: "&

"mov eax,[esi + 4] "&		--eax = y1
"cmp eax,[ebx + 4] "&		--cmp y1,y3
"jng @@y2_ng_y3 "&
  "xchg esi,ebx "&
"@@y2_ng_y3: "&

"mov eax,[edi + 4] "&		--eax = y2
"cmp eax,[ebx + 4] "&		--cmp y2,y3
"jng @@y1_ng_y3 "&
  "xchg edi,ebx "&
"@@y1_ng_y3: "&

 "mov [vertex_ptr_1],esi "&
 "mov [vertex_ptr_2],edi "&
 "mov [vertex_ptr_3],ebx "&
 "mov eax,[edi] "&
 "sub eax,[esi] "&
 "mov [delta_x_1],eax "&

 "mov eax,[ebx] "&
 "sub eax,[edi] "&
 "mov [delta_x_2],eax "&

 "mov eax,[ebx] "&		
 "sub eax,[esi] "&		
 "mov [delta_x_3],eax "&

 "mov eax,[edi + 4] "&
 "sub eax,[esi + 4] "&
 "mov [delta_y_1],eax "&

 "mov eax,[ebx + 4] "&
 "sub eax,[edi + 4] "&
 "mov [delta_y_2],eax "&

 "mov eax,[ebx + 4] "&		
 "sub eax,[esi + 4] "&		
 "mov [delta_y_3],eax "&

 "mov ax,[edi+8] "&
 "mov dx,[esi+8] "&
 "and eax,31 "&
 "and edx,31 "&
 "sub eax,edx "& 
 "mov [delta_b_1],eax "&
 "mov ax,[ebx+8] "&
 "and eax,31 "&
 "sub eax,edx "& 
 "mov [delta_b_3],eax "&
 "mov ax,[ebx+8] "&
 "mov dx,[edi+8] "&
 "and eax,31 "&
 "and edx,31 "&
 "sub eax,edx "& 
 "mov [delta_b_2],eax "&

 "mov ax,[edi+8] "&
 "mov dx,[esi+8] "&
 "and eax,2016 "&
 "and edx,2016 "&
 "shr eax,5 "&
 "shr edx,5 "&
 "sub eax,edx "& 
 "mov [delta_g_1],eax "&
 "mov ax,[ebx+8] "&
 "and eax,2016 "&
 "shr eax,5 "&
 "sub eax,edx "& 
 "mov [delta_g_3],eax "&
 "mov ax,[ebx+8] "&
 "mov dx,[edi+8] "&
 "and eax,2016 "&
 "and edx,2016 "&
 "shr eax,5 "&
 "shr edx,5 "&
 "sub eax,edx "& 
 "mov [delta_g_2],eax "&

 "mov ax,[edi+8] "&
 "mov dx,[esi+8] "&
 "and eax,63488 "&
 "and edx,63488 "&
 "shr eax,11 "&
 "shr edx,11 "&
 "sub eax,edx "& 
 "mov [delta_r_1],eax "&
 "mov ax,[ebx+8] "&
 "and eax,63488 "&
 "shr eax,11 "&
 "sub eax,edx "& 
 "mov [delta_r_3],eax "&
 "mov ax,[ebx+8] "&
 "mov dx,[edi+8] "&
 "and eax,63488 "&
 "and edx,63488 "&
 "shr eax,11 "&
 "shr edx,11 "&
 "sub eax,edx "& 
 "mov [delta_r_2],eax "&

  "mov eax,[delta_x_3] "&
  "sal eax,9 "&
  "mov ebx,[delta_y_3] "&
  "or ebx,ebx "&
  "setz dl "&
  "or bl,dl "&
  "cwd "&
  "idiv ebx "&
  "mov [d_3],eax "&
  "mov eax,[delta_r_3] "&
  "sal eax,11 "&
  "cwd "&
  "idiv ebx "&
  "mov [dr_3],eax "&
  "mov eax,[delta_g_3] "&
  "sal eax,8 "&
  "cwd "&
  "idiv ebx "&
  "mov [dg_3],eax "&
  "mov eax,[delta_b_3] "&
  "sal eax,8 "&
  "cwd "&
  "idiv ebx "&
  "mov [db_3],eax "&

  "mov eax,[delta_x_2] "&
  "sal eax,9 "&
  "mov ebx,[delta_y_2] "&
  "or ebx,ebx "&
  "setz dl "&
  "or bl,dl "&
  "cwd "&
  "idiv ebx "&
  "mov [d_2],eax "&
  "mov eax,[delta_r_2] "&
  "sal eax,11 "&
  "cwd "&
  "idiv ebx "&
  "mov [dr_2],eax "&
  "mov eax,[delta_g_2] "&
  "sal eax,8 "&
  "cwd "&
  "idiv ebx "&
  "mov [dg_2],eax "&
  "mov eax,[delta_b_2] "&
  "sal eax,8 "&
  "cwd "&
  "idiv ebx "&
  "mov [db_2],eax "&

  "mov eax,[delta_x_1] "&
  "sal eax,9 "&
  "mov ebx,[delta_y_1] "&
  "or ebx,ebx "&
  "setz dl "&
  "or bl,dl "&
  "cwd "&
  "idiv ebx "&
  "mov [d_1],eax "&
  "mov eax,[delta_r_1] "&
  "sal eax,11 "&
  "cwd "&
  "idiv ebx "&
  "mov [dr_1],eax "&
  "mov eax,[delta_g_1] "&
  "sal eax,8 "&
  "cwd "&
  "idiv ebx "&
  "mov [dg_1],eax "&
  "mov eax,[delta_b_1] "&
  "sal eax,8 "&
  "cwd "&
  "idiv ebx "&
  "mov [db_1],eax "&

"mov eax,[vertex_ptr_1] "&
"mov ebx,[vertex_ptr_2] "&
"mov edx,[eax + 4] "&
"mov eax,[ebx + 4] "&
"mov [start_y],edx "&
"mov [end_y],eax "&
"mov esi,[vertex_ptr_1] "&
"mov eax,[esi] "&
"sal eax,9 "&
"mov [x1],eax "&
"mov [x2],eax "&

"mov ax,[esi+8] "&
"mov ebx,eax "&
"mov ecx,eax "&
"and eax,31 "&
"shl eax,8 "&
"and ebx,2016 "&
"lea ebx,[ebx*8] "&
"and ecx,63488 "&

"mov [b1],eax "&
"mov [g1],ebx "&
"mov [r1],ecx "&
"mov [b2],eax "&
"mov [g2],ebx "&
"mov [r2],ecx "&

"mov eax,[d_1] "&
"mov ebx,[d_3] "&
"mov ecx,[dr_1] "&
"mov edx,[dr_3] "&
"mov [dxdy_1],eax "&
"mov [dxdy_2],ebx "&
"mov [drdy_1],ecx "&
"mov [drdy_2],edx "&
"mov eax,[dg_1] "&
"mov ebx,[dg_3] "&
"mov ecx,[db_1] "&
"mov edx,[db_3] "&
"mov [dgdy_1],eax "&
"mov [dgdy_2],ebx "&
"mov [dbdy_1],ecx "&
"mov [dbdy_2],edx "&
"mov edi,[tri_dest] "&
"mov ebx,draw_section "&
"call near ebx "&			--draw upper section

"mov ebx,[vertex_ptr_2] "&
"mov eax,[ebx] "&
"sal eax,9 "&
"mov [x1],eax "&
"mov ax,[ebx+8] "&
"mov ebx,eax "&
"mov ecx,eax "&
"and eax,31 "&
"shl eax,8 "&
"and ebx,2016 "&
"lea ebx,[ebx*8] "&
"and ecx,63488 "&
"mov [b1],eax "&
"mov [g1],ebx "&
"mov [r1],ecx "&
"mov eax,[vertex_ptr_2] "&
"mov ebx,[vertex_ptr_3] "&
"mov edx,[eax + 4] "&
"mov eax,[ebx + 4] "&
"mov [start_y],edx "&
"mov [end_y],eax "&
"mov eax,[d_2] "&
"mov ebx,[d_3] "&
"mov ecx,[dr_2] "&
"mov edx,[dr_3] "&
"mov [dxdy_1],eax "&
"mov [dxdy_2],ebx "&
"mov [drdy_1],ecx "&
"mov [drdy_2],edx "&
"mov eax,[dg_2] "&
"mov ebx,[dg_3] "&
"mov ecx,[db_2] "&
"mov edx,[db_3] "&
"mov [dgdy_1],eax "&
"mov [dgdy_2],ebx "&
"mov [dbdy_1],ecx "&
"mov [dbdy_2],edx "&
"mov edi,[tri_dest] "&
"mov ebx,draw_section "&
"call near ebx "&			--draw lower section
"popa "&
"ret")
resolve_param("vertex_ptr_1",poly_data)
resolve_param("vertex_ptr_2",poly_data+4)
resolve_param("vertex_ptr_3",poly_data+8)
resolve_param("delta_x_1",poly_data+16)
resolve_param("delta_x_2",poly_data+20)
resolve_param("delta_x_3",poly_data+24)
resolve_param("delta_y_1",poly_data+32)
resolve_param("delta_y_2",poly_data+36)
resolve_param("delta_y_3",poly_data+40)
resolve_param("delta_r_1",poly_data+160)
resolve_param("delta_r_2",poly_data+164)
resolve_param("delta_r_3",poly_data+168)
resolve_param("delta_g_1",poly_data+172)
resolve_param("delta_g_2",poly_data+176)
resolve_param("delta_g_3",poly_data+180)
resolve_param("delta_b_1",poly_data+184)
resolve_param("delta_b_2",poly_data+188)
resolve_param("delta_b_3",poly_data+192)
resolve_param("d_1",poly_data+48)
resolve_param("d_2",poly_data+52)
resolve_param("d_3",poly_data+56)
resolve_param("dr_1",poly_data+196)
resolve_param("dr_2",poly_data+200)
resolve_param("dr_3",poly_data+204)
resolve_param("dg_1",poly_data+208)
resolve_param("dg_2",poly_data+212)
resolve_param("dg_3",poly_data+216)
resolve_param("db_1",poly_data+220)
resolve_param("db_2",poly_data+224)
resolve_param("db_3",poly_data+228)
resolve_param("dxdy_1",poly_data+64)
resolve_param("dxdy_2",poly_data+68)
resolve_param("drdy_1",poly_data+232)
resolve_param("drdy_2",poly_data+236)
resolve_param("dgdy_1",poly_data+240)
resolve_param("dgdy_2",poly_data+244)
resolve_param("dbdy_1",poly_data+248)
resolve_param("dbdy_2",poly_data+252)
resolve_param("tri_dest",poly_data+72)
resolve_param("draw_section",drawgouraudsection16)
resolve_param("start_y",poly_data+112)
resolve_param("end_y",poly_data+120)
resolve_param("x1",poly_data+128)
resolve_param("x2",poly_data+132)
resolve_param("r1",poly_data+256)
resolve_param("g1",poly_data+260)
resolve_param("b1",poly_data+264)
resolve_param("r2",poly_data+268)
resolve_param("g2",poly_data+272)
resolve_param("b2",poly_data+276)



-- color interpolation:
--  R : 00000000 wwwwwwww ffffffff
--  G : 00000000 wwwwwwww ffffffff
--  B : 00000000 wwwwwwww ffffffff
--
-- (w=whole, f=frac)

constant gtri24=get_asm(
"pusha "&
"cld "&
"mov esi,[vertex_ptr_1] "&
"mov edi,[vertex_ptr_2] "&
"mov ebx,[vertex_ptr_3] "&

"mov eax,[esi + 4] "&		--eax = y1
"cmp eax,[edi + 4] "&		--cmp y1,y2
"jng @@y1_ng_y2 "&
  "xchg esi,edi "&
"@@y1_ng_y2: "&

"mov eax,[esi + 4] "&		--eax = y1
"cmp eax,[ebx + 4] "&		--cmp y1,y3
"jng @@y2_ng_y3 "&
  "xchg esi,ebx "&
"@@y2_ng_y3: "&

"mov eax,[edi + 4] "&		--eax = y2
"cmp eax,[ebx + 4] "&		--cmp y2,y3
"jng @@y1_ng_y3 "&
  "xchg edi,ebx "&
"@@y1_ng_y3: "&

 "mov [vertex_ptr_1],esi "&
 "mov [vertex_ptr_2],edi "&
 "mov [vertex_ptr_3],ebx "&
 "mov eax,[edi] "&
 "sub eax,[esi] "&
 "mov [delta_x_1],eax "&

 "mov eax,[ebx] "&
 "sub eax,[edi] "&
 "mov [delta_x_2],eax "&

 "mov eax,[ebx] "&		
 "sub eax,[esi] "&		
 "mov [delta_x_3],eax "&

 "mov eax,[edi + 4] "&
 "sub eax,[esi + 4] "&
 "mov [delta_y_1],eax "&

 "mov eax,[ebx + 4] "&
 "sub eax,[edi + 4] "&
 "mov [delta_y_2],eax "&

 "mov eax,[ebx + 4] "&		
 "sub eax,[esi + 4] "&		
 "mov [delta_y_3],eax "&

 "mov ax,[edi+8] "&
 "mov dx,[esi+8] "&
 "and eax,255 "&
 "and edx,255 "&
 "sub eax,edx "& 
 "mov [delta_b_1],eax "&
 "mov ax,[ebx+8] "&
 "and eax,255 "&
 "sub eax,edx "& 
 "mov [delta_b_3],eax "&
 "mov ax,[ebx+8] "&
 "mov dx,[edi+8] "&
 "and eax,255 "&
 "and edx,255 "&
 "sub eax,edx "& 
 "mov [delta_b_2],eax "&

 "mov ax,[edi+8] "&
 "mov dx,[esi+8] "&
 "and eax,65280 "&
 "and edx,65280 "&
 "xchg al,ah "&
 "xchg dl,dh "&
 "sub eax,edx "& 
 "mov [delta_g_1],eax "&
 "mov ax,[ebx+8] "&
 "and eax,65280 "&
 "xchg al,ah "&
 "sub eax,edx "& 
 "mov [delta_g_3],eax "&
 "mov ax,[ebx+8] "&
 "mov dx,[edi+8] "&
 "and eax,65280 "&
 "and edx,65280 "&
 "xchg al,ah "&
 "xchg dl,dh "&
 "sub eax,edx "& 
 "mov [delta_g_2],eax "&

 "mov eax,[edi+8] "&
 "mov edx,[esi+8] "&
 "shr eax,16 "&
 "shr edx,16 "&
 "sub eax,edx "& 
 "mov [delta_r_1],eax "&
 "mov eax,[ebx+8] "&
 "shr eax,16 "&
 "sub eax,edx "& 
 "mov [delta_r_3],eax "&
 "mov eax,[ebx+8] "&
 "mov edx,[edi+8] "&
 "shr eax,16 "&
 "shr edx,16 "&
 "sub eax,edx "& 
 "mov [delta_r_2],eax "&

  "mov eax,[delta_x_3] "&
  "sal eax,9 "&
  "mov ebx,[delta_y_3] "&
  "or ebx,ebx "&
  "setz dl "&
  "or bl,dl "&
  "cwd "&
  "idiv ebx "&
  "mov [d_3],eax "&
  "mov eax,[delta_r_3] "&
  "sal eax,8 "&
  "cwd "&
  "idiv ebx "&
  "mov [dr_3],eax "&
  "mov eax,[delta_g_3] "&
  "sal eax,8 "&
  "cwd "&
  "idiv ebx "&
  "mov [dg_3],eax "&
  "mov eax,[delta_b_3] "&
  "sal eax,8 "&
  "cwd "&
  "idiv ebx "&
  "mov [db_3],eax "&

  "mov eax,[delta_x_2] "&
  "sal eax,9 "&
  "mov ebx,[delta_y_2] "&
  "or ebx,ebx "&
  "setz dl "&
  "or bl,dl "&
  "cwd "&
  "idiv ebx "&
  "mov [d_2],eax "&
  "mov eax,[delta_r_2] "&
  "sal eax,8 "&
  "cwd "&
  "idiv ebx "&
  "mov [dr_2],eax "&
  "mov eax,[delta_g_2] "&
  "sal eax,8 "&
  "cwd "&
  "idiv ebx "&
  "mov [dg_2],eax "&
  "mov eax,[delta_b_2] "&
  "sal eax,8 "&
  "cwd "&
  "idiv ebx "&
  "mov [db_2],eax "&

  "mov eax,[delta_x_1] "&
  "sal eax,9 "&
  "mov ebx,[delta_y_1] "&
  "or ebx,ebx "&
  "setz dl "&
  "or bl,dl "&
  "cwd "&
  "idiv ebx "&
  "mov [d_1],eax "&
  "mov eax,[delta_r_1] "&
  "sal eax,8 "&
  "cwd "&
  "idiv ebx "&
  "mov [dr_1],eax "&
  "mov eax,[delta_g_1] "&
  "sal eax,8 "&
  "cwd "&
  "idiv ebx "&
  "mov [dg_1],eax "&
  "mov eax,[delta_b_1] "&
  "sal eax,8 "&
  "cwd "&
  "idiv ebx "&
  "mov [db_1],eax "&

"mov eax,[vertex_ptr_1] "&
"mov ebx,[vertex_ptr_2] "&
"mov edx,[eax + 4] "&
"mov eax,[ebx + 4] "&
"mov [start_y],edx "&
"mov [end_y],eax "&
"mov esi,[vertex_ptr_1] "&
"mov eax,[esi] "&
"sal eax,9 "&
"mov [x1],eax "&
"mov [x2],eax "&

"mov eax,[esi+8] "&
"mov ebx,eax "&
"mov ecx,eax "&
"and eax,255 "&
"shl eax,8 "&
"and ebx,65280 "&
"shr ecx,8 "&
"and ecx,65280 "&

"mov [b1],eax "&
"mov [g1],ebx "&
"mov [r1],ecx "&
"mov [b2],eax "&
"mov [g2],ebx "&
"mov [r2],ecx "&

"mov eax,[d_1] "&
"mov ebx,[d_3] "&
"mov ecx,[dr_1] "&
"mov edx,[dr_3] "&
"mov [dxdy_1],eax "&
"mov [dxdy_2],ebx "&
"mov [drdy_1],ecx "&
"mov [drdy_2],edx "&
"mov eax,[dg_1] "&
"mov ebx,[dg_3] "&
"mov ecx,[db_1] "&
"mov edx,[db_3] "&
"mov [dgdy_1],eax "&
"mov [dgdy_2],ebx "&
"mov [dbdy_1],ecx "&
"mov [dbdy_2],edx "&
"mov edi,[tri_dest] "&
"mov ebx,draw_section "&
"call near ebx "&			--draw upper section

"mov ebx,[vertex_ptr_2] "&
"mov eax,[ebx] "&
"sal eax,9 "&
"mov [x1],eax "&
"mov eax,[ebx+8] "&
"mov ebx,eax "&
"mov ecx,eax "&
"and eax,255 "&
"shl eax,8 "&
"and ebx,65280 "&
"shr ecx,8 "&
"and ecx,65280 "&
"mov [b1],eax "&
"mov [g1],ebx "&
"mov [r1],ecx "&
"mov eax,[vertex_ptr_2] "&
"mov ebx,[vertex_ptr_3] "&
"mov edx,[eax + 4] "&
"mov eax,[ebx + 4] "&
"mov [start_y],edx "&
"mov [end_y],eax "&
"mov eax,[d_2] "&
"mov ebx,[d_3] "&
"mov ecx,[dr_2] "&
"mov edx,[dr_3] "&
"mov [dxdy_1],eax "&
"mov [dxdy_2],ebx "&
"mov [drdy_1],ecx "&
"mov [drdy_2],edx "&
"mov eax,[dg_2] "&
"mov ebx,[dg_3] "&
"mov ecx,[db_2] "&
"mov edx,[db_3] "&
"mov [dgdy_1],eax "&
"mov [dgdy_2],ebx "&
"mov [dbdy_1],ecx "&
"mov [dbdy_2],edx "&
"mov edi,[tri_dest] "&
"mov ebx,draw_section "&
"call near ebx "&			--draw lower section
"popa "&
"ret")
resolve_param("vertex_ptr_1",poly_data)
resolve_param("vertex_ptr_2",poly_data+4)
resolve_param("vertex_ptr_3",poly_data+8)
resolve_param("delta_x_1",poly_data+16)
resolve_param("delta_x_2",poly_data+20)
resolve_param("delta_x_3",poly_data+24)
resolve_param("delta_y_1",poly_data+32)
resolve_param("delta_y_2",poly_data+36)
resolve_param("delta_y_3",poly_data+40)
resolve_param("delta_r_1",poly_data+160)
resolve_param("delta_r_2",poly_data+164)
resolve_param("delta_r_3",poly_data+168)
resolve_param("delta_g_1",poly_data+172)
resolve_param("delta_g_2",poly_data+176)
resolve_param("delta_g_3",poly_data+180)
resolve_param("delta_b_1",poly_data+184)
resolve_param("delta_b_2",poly_data+188)
resolve_param("delta_b_3",poly_data+192)
resolve_param("d_1",poly_data+48)
resolve_param("d_2",poly_data+52)
resolve_param("d_3",poly_data+56)
resolve_param("dr_1",poly_data+196)
resolve_param("dr_2",poly_data+200)
resolve_param("dr_3",poly_data+204)
resolve_param("dg_1",poly_data+208)
resolve_param("dg_2",poly_data+212)
resolve_param("dg_3",poly_data+216)
resolve_param("db_1",poly_data+220)
resolve_param("db_2",poly_data+224)
resolve_param("db_3",poly_data+228)
resolve_param("dxdy_1",poly_data+64)
resolve_param("dxdy_2",poly_data+68)
resolve_param("drdy_1",poly_data+232)
resolve_param("drdy_2",poly_data+236)
resolve_param("dgdy_1",poly_data+240)
resolve_param("dgdy_2",poly_data+244)
resolve_param("dbdy_1",poly_data+248)
resolve_param("dbdy_2",poly_data+252)
resolve_param("tri_dest",poly_data+72)
resolve_param("draw_section",drawgouraudsection24)
resolve_param("start_y",poly_data+112)
resolve_param("end_y",poly_data+120)
resolve_param("x1",poly_data+128)
resolve_param("x2",poly_data+132)
resolve_param("r1",poly_data+256)
resolve_param("g1",poly_data+260)
resolve_param("b1",poly_data+264)
resolve_param("r2",poly_data+268)
resolve_param("g2",poly_data+272)
resolve_param("b2",poly_data+276)



-- texture interpolation:
--  U : wwwwwwww wwwwwwww ffffffff
--  V : wwwwwwww wwwwwwww ffffffff
--
-- (w=whole, f=frac)

constant ttri=get_asm(
"pusha "&
"cld "&
"mov esi,[vertex_ptr_1] "&
"mov edi,[vertex_ptr_2] "&
"mov ebx,[vertex_ptr_3] "&

"mov eax,[esi + 4] "&		--eax = y1
"cmp eax,[edi + 4] "&		--cmp y1,y2
"jng @@y1_ng_y2 "&
  "xchg esi,edi "&
"@@y1_ng_y2: "&

"mov eax,[esi + 4] "&		--eax = y1
"cmp eax,[ebx + 4] "&		--cmp y1,y3
"jng @@y2_ng_y3 "&
  "xchg esi,ebx "&
"@@y2_ng_y3: "&

"mov eax,[edi + 4] "&		--eax = y2
"cmp eax,[ebx + 4] "&		--cmp y2,y3
"jng @@y1_ng_y3 "&
  "xchg edi,ebx "&
"@@y1_ng_y3: "&

 "mov [vertex_ptr_1],esi "&
 "mov [vertex_ptr_2],edi "&
 "mov [vertex_ptr_3],ebx "&
 "mov eax,[edi] "&
 "sub eax,[esi] "&
 "mov [delta_x_1],eax "&

 "mov eax,[ebx] "&
 "sub eax,[edi] "&
 "mov [delta_x_2],eax "&

 "mov eax,[ebx] "&		
 "sub eax,[esi] "&		
 "mov [delta_x_3],eax "&

 "mov eax,[edi + 4] "&
 "sub eax,[esi + 4] "&
 "mov [delta_y_1],eax "&

 "mov eax,[ebx + 4] "&
 "sub eax,[edi + 4] "&
 "mov [delta_y_2],eax "&

 "mov eax,[ebx + 4] "&		
 "sub eax,[esi + 4] "&		
 "mov [delta_y_3],eax "&

 "mov ax,[edi+8] "&
 "mov dx,[esi+8] "&
 "and eax,255 "&
 "and edx,255 "&
 "sub eax,edx "& 
 "mov [delta_u_1],eax "&
 "mov ax,[ebx+8] "&
 "and eax,255 "&
 "sub eax,edx "& 
 "mov [delta_u_3],eax "&
 "mov ax,[ebx+8] "&
 "mov dx,[edi+8] "&
 "and eax,255 "&
 "and edx,255 "&
 "sub eax,edx "& 
 "mov [delta_u_2],eax "&

 "mov ax,[edi+12] "&
 "mov dx,[esi+12] "&
 "and eax,255 "&
 "and edx,255 "&
 "sub eax,edx "& 
 "mov [delta_v_1],eax "&
 "mov ax,[ebx+12] "&
 "and eax,255 "&
 "sub eax,edx "& 
 "mov [delta_v_3],eax "&
 "mov ax,[ebx+12] "&
 "mov dx,[edi+12] "&
 "and eax,255 "&
 "and edx,255 "&
 "sub eax,edx "& 
 "mov [delta_v_2],eax "&

  "mov eax,[delta_x_3] "&
  "sal eax,9 "&
  "mov ebx,[delta_y_3] "&
  "or ebx,ebx "&
  "setz dl "&
  "or bl,dl "&
  "cwd "&
  "idiv ebx "&
  "mov [d_3],eax "&
  "mov eax,[delta_u_3] "&
  "sal eax,16 "&
  "cwd "&
  "idiv ebx "&
  "mov [du_3],eax "&
  "mov eax,[delta_v_3] "&
  "sal eax,16 "&
  "cwd "&
  "idiv ebx "&
  "mov [dv_3],eax "&

  "mov eax,[delta_x_2] "&
  "sal eax,9 "&
  "mov ebx,[delta_y_2] "&
  "or ebx,ebx "&
  "setz dl "&
  "or bl,dl "&
  "cwd "&
  "idiv ebx "&
  "mov [d_2],eax "&
  "mov eax,[delta_u_2] "&
  "sal eax,16 "&
  "cwd "&
  "idiv ebx "&
  "mov [du_2],eax "&
  "mov eax,[delta_v_2] "&
  "sal eax,16 "&
  "cwd "&
  "idiv ebx "&
  "mov [dv_2],eax "&

  "mov eax,[delta_x_1] "&
  "sal eax,9 "&
  "mov ebx,[delta_y_1] "&
  "or ebx,ebx "&
  "setz dl "&
  "or bl,dl "&
  "cwd "&
  "idiv ebx "&
  "mov [d_1],eax "&
  "mov eax,[delta_u_1] "&
  "sal eax,16 "&
  "cwd "&
  "idiv ebx "&
  "mov [du_1],eax "&
  "mov eax,[delta_v_1] "&
  "sal eax,16 "&
  "cwd "&
  "idiv ebx "&
  "mov [dv_1],eax "&

"mov eax,[vertex_ptr_1] "&
"mov ebx,[vertex_ptr_2] "&
"mov edx,[eax + 4] "&
"mov eax,[ebx + 4] "&
"mov [start_y],edx "&
"mov [end_y],eax "&
"mov esi,[vertex_ptr_1] "&
"mov eax,[esi] "&
"sal eax,9 "&
"mov [x1],eax "&
"mov [x2],eax "&

"mov eax,[esi+8] "&
"mov ebx,[esi+12] "&
"shl eax,16 "&
"shl ebx,16 "&

"mov [u1],eax "&
"mov [v1],ebx "&
"mov [u2],eax "&
"mov [v2],ebx "&

"mov eax,[d_1] "&
"mov ebx,[d_3] "&
"mov ecx,[du_1] "&
"mov edx,[du_3] "&
"mov [dxdy_1],eax "&
"mov [dxdy_2],ebx "&
"mov [dudy_1],ecx "&
"mov [dudy_2],edx "&
"mov eax,[dv_1] "&
"mov ebx,[dv_3] "&
"mov [dvdy_1],eax "&
"mov [dvdy_2],ebx "&
"mov edi,[tri_dest] "&
"mov ebx,[draw_section] "&
"call near ebx "&			--draw upper section

"mov ebx,[vertex_ptr_2] "&
"mov eax,[ebx] "&
"sal eax,9 "&
"mov [x1],eax "&
"mov eax,[ebx+8] "&
"mov ebx,[ebx+12] "&
"shl eax,16 "&
"shl ebx,16 "&
"mov [u1],eax "&
"mov [v1],ebx "&

"mov eax,[vertex_ptr_2] "&
"mov ebx,[vertex_ptr_3] "&
"mov edx,[eax + 4] "&
"mov eax,[ebx + 4] "&
"mov [start_y],edx "&
"mov [end_y],eax "&
"mov eax,[d_2] "&
"mov ebx,[d_3] "&
"mov ecx,[du_2] "&
"mov edx,[du_3] "&
"mov [dxdy_1],eax "&
"mov [dxdy_2],ebx "&
"mov [dudy_1],ecx "&
"mov [dudy_2],edx "&
"mov eax,[dv_2] "&
"mov ebx,[dv_3] "&
"mov [dvdy_1],eax "&
"mov [dvdy_2],ebx "&
"mov edi,[tri_dest] "&
"mov ebx,[draw_section] "&
"call near ebx "&			--draw lower section
"popa "&
"ret")
resolve_param("vertex_ptr_1",poly_data)
resolve_param("vertex_ptr_2",poly_data+4)
resolve_param("vertex_ptr_3",poly_data+8)
resolve_param("delta_x_1",poly_data+16)
resolve_param("delta_x_2",poly_data+20)
resolve_param("delta_x_3",poly_data+24)
resolve_param("delta_y_1",poly_data+32)
resolve_param("delta_y_2",poly_data+36)
resolve_param("delta_y_3",poly_data+40)
resolve_param("delta_u_1",poly_data+160)
resolve_param("delta_u_2",poly_data+164)
resolve_param("delta_u_3",poly_data+168)
resolve_param("delta_v_1",poly_data+172)
resolve_param("delta_v_2",poly_data+176)
resolve_param("delta_v_3",poly_data+180)
resolve_param("d_1",poly_data+48)
resolve_param("d_2",poly_data+52)
resolve_param("d_3",poly_data+56)
resolve_param("du_1",poly_data+196)
resolve_param("du_2",poly_data+200)
resolve_param("du_3",poly_data+204)
resolve_param("dv_1",poly_data+208)
resolve_param("dv_2",poly_data+212)
resolve_param("dv_3",poly_data+216)
resolve_param("dxdy_1",poly_data+64)
resolve_param("dxdy_2",poly_data+68)
resolve_param("dudy_1",poly_data+232)
resolve_param("dudy_2",poly_data+236)
resolve_param("dvdy_1",poly_data+240)
resolve_param("dvdy_2",poly_data+244)
resolve_param("tri_dest",poly_data+72)
resolve_param("draw_section",rTextureCode)
resolve_param("start_y",poly_data+112)
resolve_param("end_y",poly_data+120)
resolve_param("x1",poly_data+128)
resolve_param("x2",poly_data+132)
resolve_param("u1",poly_data+256)
resolve_param("v1",poly_data+260)
resolve_param("u2",poly_data+268)
resolve_param("v2",poly_data+272)






global procedure draw_tri(sequence triCoords,integer triCol,atom triAddr)
 if render_bytesPerPixel=1 then
  poke(poly_data+76,{triCol,triCol,triCol,triCol})
 elsif render_bytesPerPixel=3 then
  poke4(poly_data+76,triCol)
 else
  poke_word(poly_data+76,{triCol,triCol})
 end if  
 poke4(poly_data+72,triAddr)

 poke4(poly_data+80,triCoords[1])
 poke4(poly_data,poly_data+80)
 poke4(poly_data+88,triCoords[2])
 poke4(poly_data+4,poly_data+88)
 poke4(poly_data+96,triCoords[3])
 poke4(poly_data+8,poly_data+96)

 call(tri)
end procedure


global procedure draw_gouraudtri(sequence triCoords,sequence triCol,atom triAddr)
 poke4(poly_data+72,triAddr)

 poke4(poly_data+280,triCoords[1])
 poke4(poly_data+288,triCol[1])
 poke4(poly_data,poly_data+280)
 poke4(poly_data+292,triCoords[2])
 poke4(poly_data+300,triCol[2])
 poke4(poly_data+4,poly_data+292)
 poke4(poly_data+304,triCoords[3])
 poke4(poly_data+312,triCol[3])
 poke4(poly_data+8,poly_data+304)

 call(gouraud_code)
end procedure


global procedure draw_texturetri(sequence triCoords,sequence texCoords,atom tex_ptr,atom triAddr)
 poke4(poly_data+72,triAddr)
 poke4(rTexture,tex_ptr)

 poke4(poly_data+280,triCoords[1])
 poke4(poly_data+288,texCoords[1])
 poke4(poly_data,poly_data+280)
 poke4(poly_data+296,triCoords[2])
 poke4(poly_data+304,texCoords[2])
 poke4(poly_data+4,poly_data+296)
 poke4(poly_data+312,triCoords[3])
 poke4(poly_data+320,texCoords[3])
 poke4(poly_data+8,poly_data+312)

 call(ttri)
end procedure






constant fcopy_code=get_asm(
"pusha cld "&
"mov edi,fcopy_dest "&
"mov esi,fcopy_src "&
"add edi,[fcopy_screenSize] "&
"add esi,[fcopy_screenSize] "&
"mov ecx,[fcopy_iterations] "&
"fcopy_@loop: "&
"fild qword ptr [esi + ecx*8] "&
"fistp qword ptr [edi + ecx*8] "&
"inc ecx "&
"fild qword ptr [esi + ecx*8] "&
"fistp qword ptr [edi + ecx*8] "&
"inc ecx "&
"fild qword ptr [esi + ecx*8] "&
"fistp qword ptr [edi + ecx*8] "&
"inc ecx "&
"fild qword ptr [esi + ecx*8] "&
"fistp qword ptr [edi + ecx*8] "&
"inc ecx "&
"jnz fcopy_@loop "&
"popa ret ")
constant fcopy_dest=fcopy_code+get_param("fcopy_dest")
constant fcopy_src=fcopy_code+get_param("fcopy_src")
resolve_param("fcopy_screenSize",rBytesOnScreen)
resolve_param("fcopy_iterations",rFCopyIter)

global procedure fcopy_screen(atom dest,atom src)
 poke4(fcopy_src,src)
 poke4(fcopy_dest,dest)
 call(fcopy_code)
end procedure


constant fcls_code=get_asm(
"pusha cld "&
"mov edi,fcls_dest "&
"add edi,[fcls_screenSize] "&
"mov ecx,[fcls_iterations] "&
"fldz "&
"fcls_@loop: "&
"fst qword ptr [edi + ecx*8] "&
"inc ecx "&
"jnz fcls_@loop "&
"mov eax,-8 "&
"fstp qword ptr [edi + eax] "&
"popa ret ")
constant fcls_dest=fcls_code+get_param("fcls_dest")
resolve_param("fcls_screenSize",rBytesOnScreen)
resolve_param("fcls_iterations",rFCopyIter)

global procedure fcls(atom dest)
 poke4(fcls_dest,dest)
 call(fcls_code)
end procedure




global function render_mode(integer w,integer h,integer bpp)
   render_screenW = w
   render_maxW = w-1
   render_screenH = h
   render_maxH = h-1
   render_bytesPerPixel=floor((bpp+1)/8)
   poke4(rScreenW,render_screenW)
   poke4(rMaxW,render_maxW)
   poke4(rScreenH,render_screenH)
   poke4(rMaxH,render_maxH)
   poke4(rBytesOnScreen,(w*h*render_bytesPerPixel))
   poke4(rFCopyIter,-(floor((w*h*render_bytesPerPixel)/8)))
   poke4(rClsIter,floor((w*h*render_bytesPerPixel)/4))

   if bpp=8 then
     poke4(rFlatCode,drawsection8)
     poke4(rTextureCode,drawtexturesection8)
--     poke4(rTextureCode,drawtiledtexturesection8)
     poke4(rGouraudCode,drawgouraudsection8)
     gouraud_code = gtri

   elsif (bpp=16) or (bpp=15) then
     poke4(rFlatCode,drawsection1516)
     poke4(rTextureCode,drawtexturesection1516)
--     poke4(rTextureCode,drawtiledtexturesection1516)
     if bpp=16 then
       gouraud_code = gtri16
     else
       gouraud_code = gtri15
     end if 
   elsif (bpp=24) then
     poke4(rFlatCode,drawsection24)
     poke4(rTextureCode,drawtexturesection24)
--     poke4(rTextureCode,drawtiledtexturesection24)
     gouraud_code = gtri24
   end if
   return 0
end function




